#!/usr/bin/wish -f

#########################################################
#                                                       #
#              GenomePixelizer - 2.4.7                  #
#              -----------------------                  #
#     Author: Alexander Kozik & Elena Kochetkova        #
#                Date: June/24/2003                     #
#                                                       #
#########################################################

##########################################
#                                        #
####### THE LIST OF PROCEDURES ###########
#       ----------------------           #
##########################################

##########################
#      GNU LICENSE       #
##########################
proc About_GenPix {} {

    set gen_pix_logo [image create photo -height 161 -width 163 \
    -file ./Images/GenomePixelizerLogo.gif]
    set gen_pix_text "GenomePixelizer (Genome Visualization Tool)

Copyright (C) 2001, 2002, 2003 University of California at Davis
Department of Vegetable Crops, Michelmore lab., E.Kochetkova and A.Kozik
    
This program is free software. You can redistribute it and/or modify it 
under the terms of the GNU General Public License ( http://www.gnu.org ) 
as published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

In other words, you are free to modify, copy, or redistribute this source 
code and its documentation in any way you like, but you must distribute 
all derivative versions as free software under the same terms that we 
provided our code to you (i.e. the GNU General Public License). This 
precludes any use of the code in proprietary or commercial software 
unless your source code is made freely available.

This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along 
with this GenomePixelizer release, in the file LICENSE; if not, write to the 
Free Software Foundation, Inc., 675 Mass. Ave, Cambridge, MA 02139 USA."

    destroy .gen_pix_about
    toplevel .gen_pix_about 
    wm transient .gen_pix_about .
    wm title .gen_pix_about "About GenomePixelizer"
    wm protocol .gen_pix_about WM_DELETE_WINDOW "destroy .gen_pix_about"

    label .gen_pix_about.image -image $gen_pix_logo
    label .gen_pix_about.text -text $gen_pix_text -justify center
    button .gen_pix_about.ok -text "OK" -command "destroy .gen_pix_about"
    grid .gen_pix_about.image -padx 7 -pady 7
    grid .gen_pix_about.text -padx 2 -pady 2
    grid .gen_pix_about.ok -padx 2 -pady 2
}

########################################################################
#                    Full List of Procedures                           #
########################################################################
#############################################################
### proc About_GenPix
### proc About_Supplement
### proc Add_Graphics_to_Canvas
### proc AssignBorder
### proc AssignColor
### proc Be_Patient
### proc Be_Patient_Matrix
### proc Canvas_Editor
### proc Canvas_Html_Size
### proc Change_Node_Color1
### proc Change_Node_Color2
### proc Change_Node_Color3
### proc Change_Node_Color4
### proc Change_Node_Color5
### proc Change_Node_Color6
### proc Check_Bad_Matrix_A
### proc Check_Bad_Matrix_B
### proc Color_Error_Report
### proc Compare_with_Matrix_A
### proc Compare_with_Matrix_B
### proc Delete_Graph_Item
### proc Delete_Text_Item
### proc Destroy_Alignment
### proc Destroy_Graph_and_Dismiss
### proc Destroy_Text_and_Dismiss
### proc DrawChromosome
### proc DrawGenes_Ext
### proc DrawGenes_Std
### proc DrawRuler
### proc Draw_Alignment
### proc End_Be_Patient
### proc Family_Color_Error_Report
### proc FindLargest
### proc Fine_Matrix_Color
### proc Generate_Sub_Project
### proc GenPix_Tutorial_00
### proc GenPix_Tutorial_01
### proc Genome_Pixelizer_Canvas
### proc GetCoordinates
### proc Get_Canvas_Size
### proc How_To_Alignment
### proc How_To_Edit_Canvas
### proc How_To_Validate_Matrix
### proc HowTo_Create_SubProject
### proc HowTo_Paint_Nodes
### proc Html_ScreenShot
### proc Locus_Zoomer
### proc Matrix_Validation_Done
### proc Matrix_Validator
### proc Mouse_Over_Alignment
### proc Move_Graph_Label
### proc Move_Text_Label
### proc Node_Painter
### proc Place_Text_on_Canvas
### proc PutCoordinates
### proc Read_RunSetup
### proc Reformat_ClustalW
### proc RulerLabel
### proc Scrolled_Alignment
### proc Scrolled_Canvas
### proc Scrolled_Text
### proc ShowMatchingPairs
### proc Show_AA_A
### proc Show_AA_C
### proc Show_AA_Credits
### proc Show_AA_D
### proc Show_AA_E
### proc Show_AA_F
### proc Show_AA_G
### proc Show_AA_H
### proc Show_AA_I
### proc Show_AA_K
### proc Show_AA_L
### proc Show_AA_M
### proc Show_AA_N
### proc Show_AA_P
### proc Show_AA_Q
### proc Show_AA_R
### proc Show_AA_S
### proc Show_AA_T
### proc Show_AA_V
### proc Show_AA_W
### proc Show_AA_Y
### proc Show_Color_Map
### proc Show_Color_Map_Canvas
### proc Show_CoordFile
### proc Show_CoordFile_Ext
### proc Show_CoordFile_WC
### proc Show_Documentation
### proc Show_End_Tutorial
### proc Show_Features
### proc Show_Feedback
### proc Show_Gene_ID
### proc Show_HTML_File
### proc Show_MatrixFile
### proc Show_Next_Tutorial_02
### proc Show_Next_Tutorial_03
### proc Show_Next_Tutorial_04
### proc Show_Next_Tutorial_05
### proc Show_Next_Tutorial_06
### proc Show_Next_Tutorial_07
### proc Show_Next_Tutorial_08
### proc Show_Next_Tutorial_09
### proc Show_Next_Tutorial_10
### proc Show_Next_Tutorial_11
### proc Show_RunSetupFile
### proc Show_Warning
### proc Sub_Project_Matrix
### proc View_the_Alignment
### proc WC_Correction
### proc WC_Correction_Ext
### proc highLightGene
### proc showName
#############################################################

########################################################################
#                 Full List of Global Variables                        #
########################################################################
#############################################################
### abc_tag
### alignment_background
### alignment_dir
### alignment_length
### alignment_text_color
### canvas_background
### canvas_editor_font_size
### canvas_editor_font_style
### canvas_editor_font_type
### canvas_editor_text
### chrmsmArray
### chromosome_color
### chromosome_outline
### color_A
### color_B
### color_C
### color_D
### color_E
### color_F
### color_G
### color_H
### color_I
### color_J
### color_K
### color_L
### color_M
### color_N
### color_O
### color_P
### color_Q
### color_R
### color_S
### color_T
### color_U
### color_V
### color_W
### color_X
### color_Y
### color_Z
### color_group1
### color_group2
### color_group3
### color_group4
### color_group5
### color_group6
### color_group1_outline
### color_group2_outline
### color_group3_outline
### color_group4_outline
### color_group5_outline
### color_group6_outline
### color_of_similarity_1
### color_of_similarity_2
### color_of_similarity_3
### color_of_similarity_4
### color_of_similarity_5
### color_of_similarity_6
### curX
### curY
### default_familyColor
### default_outline_gene_color
### fat_chr
### font_color_canvas
### font_color_label
### gene_color_black
### gene_color_blue
### gene_color_brown
### gene_color_cyan
### gene_color_gold
### gene_color_gray
### gene_color_green
### gene_color_lightblue
### gene_color_orange
### gene_color_pink
### gene_color_purple
### gene_color_red
### gene_color_salmon
### gene_color_violet
### gene_color_white
### gene_color_yellow
### gene_feature_mode
### graphX1
### graphX2
### graphY1
### graphY2
### graph_fill_color
### graph_outline_color
### graph_style
### graph_tag
### horizontal_size
### http_prefix
### image_title
### input_file
### input_file_to_check
### input_the_alignment
### lab_name
### level_of_similarity_1
### level_of_similarity_2
### level_of_similarity_3
### level_of_similarity_4
### level_of_similarity_5
### level_of_similarity_6
### line_counter
### loBound
### low_base_chr
### manual_correction
### matrix_file
### matrix_file_temporay_to_open
### matrix_to_validate
### max_x
### max_y
### nodes_group1
### nodes_group2
### nodes_group3
### nodes_group4
### nodes_group5
### nodes_group6
### number_of_chromosomes
### outline_gene_color
### ps_alignment_to_save
### ruler_scale_value
### selected_canvas
### size_of_gene
### size_of_gene_current
### source_file
### sub_project_chrm_A
### sub_project_chrm_A_left
### sub_project_chrm_A_order
### sub_project_chrm_A_right
### sub_project_chrm_B
### sub_project_chrm_B_left
### sub_project_chrm_B_order
### sub_project_chrm_B_right
### sub_project_coord_to_process
### sub_project_file_coord
### sub_project_file_matrix
### sub_project_file_setup
### sub_project_matrix_to_process
### text_tag
### upBound
### validated_matrix
### vertical_size
### vertical_size_of_gene
### wc_coefficient
### wc_corr_value
### wc_file
############################################################

##############################
#  READ RUN SETUP PROCEDURE  #
##############################

proc Read_RunSetup {} {

    global  source_file matrix_file number_of_chromosomes \
	loBound upBound horizontal_size vertical_size \
	chrmsmArray  http_prefix image_title lab_name \
	input_file manual_correction size_of_gene \
	vertical_size_of_gene wc_coefficient \
	wc_corr_value fat_chr gene_feature_mode \
	abc_tag annotation_file annotation_status

    ###########################################
    # FOR COMPATIBILITY WITH PEVIOUS VERSION: #

    set fat_chr 5
    set size_of_gene 7
    set vertical_size_of_gene 4
    set wc_coefficient 1
    set wc_corr_value 6
    set gene_feature_mode "std"

    #         END OF COMPATIBILITY            #
    ###########################################

    # set input_file "GenPix_RunSetup.txt"
    set input_data [open $input_file]
    set abc_tag "abc_"
    set annotation_status "FALSE"

    puts "-----------------------------------------------"

    set k  0
    while {[gets $input_data current_line] >= 0 } {

	set strLength [string length $current_line]
	set colonIndex [string first ":" $current_line]
		
	set data1 [string range $current_line [expr $colonIndex + 1] $strLength]
	set data2 [string trim $data1]

	if {$k == 0 && [string index $current_line 0]== "1"} {
	    set source_file $data2
	    puts "Input file: $source_file"
	}
	if {$k == 1 && [string index $current_line 0]== "2"} {
	    set matrix_file $data2
	    puts "Matrix file: $matrix_file"
	}
	if {$k == 2 && [string index $current_line 0]== "3"} {
	    set number_of_chromosomes $data2
	    puts "Number of chromosomes: $number_of_chromosomes"
	}
	if {$k == 3 && [string index $current_line 0]== "4"} {

	    set data2_length [string length $data2]
	    set range1 0

	    puts -nonewline "Chromosome size: "

	    for {set l 0} {$l < $number_of_chromosomes} {incr l} {
		set a($l) [string first " " $data2]
		set chrmsmArray($l) [string trim [string range $data2 0 $a($l)]]

		set range1 [expr $a($l) + 1]
		set data2 [string range $data2 $range1 $data2_length]
		
		if {$l == [expr $number_of_chromosomes - 1]} {
		    set data2 [string range $data2 $range1 $data2_length]
		    set chrmsmArray($l) [string trim $data2]
		}			
	    }

	    for {set m 0} {$m < $number_of_chromosomes} {incr m} {
		puts -nonewline "$chrmsmArray($m)  "

	    }
	    puts -nonewline "\n"
	}
	if {$k == 4 && [string index $current_line 0]== "5"} {
	    set upBound $data2
	    puts "Upper level of similarity: $upBound"
	}
	if {$k == 5 && [string index $current_line 0]== "6"} {
	    set loBound $data2
	    puts "Lower level of similarity: $loBound"
	}
	if {$k == 6 && [string index $current_line 0]== "7"} {
	    set horizontal_size $data2
	    puts "Original horizontal size: $horizontal_size"
	}
	if {$k == 7 && [string index $current_line 0]== "8"} {
	    set  vertical_size $data2
	    puts "Original vertical size: $vertical_size"
	}
	if {$k == 8 && [string index $current_line 0]== "9"} {
	    set  http_prefix $data2
	    puts "HTML prefix: $http_prefix"
	}
        if {$k == 9 && [string range $current_line 0 1] == "10"} {  
	    set image_title $data2
	    puts "Image title: $image_title"
	}
	if {$k == 10 && [string range $current_line 0 1] == "11"} {
	    set lab_name $data2
	    puts "Organization: $lab_name"
	}
	if {$k == 13 && [string range $current_line 0 1] == "12"} {
	    set manual_correction $data2
	    puts "Manual/Automatic correction: $manual_correction"
	}
	if {$k == 14 && [string range $current_line 0 1] == "13"} {
	    set size_of_gene $data2
	    puts "Horizontal size of gene \(pixels\): $size_of_gene"
	}
	if {$k == 15 && [string range $current_line 0 1] == "14"} {
	    set vertical_size_of_gene $data2
	    puts "Vertical size of gene \(pixels\): $vertical_size_of_gene"
	}
	if {$k == 16 && [string range $current_line 0 1] == "15"} {
	    set wc_coefficient $data2
	    puts "WC coefficient: $wc_coefficient"
	}
	if {$k == 17 && [string range $current_line 0 1] == "16"} {
	    set wc_corr_value $data2
	    puts "WC correction value: $wc_corr_value"
	}
	if {$k == 18 && [string range $current_line 0 1] == "17"} {
	    set fat_chr $data2
	    puts "Chromosome thickness: $fat_chr"
	}
	if {$k == 19 && [string range $current_line 0 1] == "18"} {
	    set gene_feature_mode $data2
	    puts "Gene feature mode (standard/extended): $gene_feature_mode"
	}
	if {$k == 22 && [string range $current_line 0 1] == "19"} {
	    set annotation_file $data2
	    set annotation_status "TRUE"
	    puts "Annotation file: $annotation_file"
	}
	incr k
    }
    puts "-----------------------------------------------"
    close $input_data
}
###########################################
#                                         #
#        GenomePixelizer Canvas           #
#                                         #
###########################################
proc Genome_Pixelizer_Canvas {} {

    destroy .genpix
    destroy .idlabel

    Be_Patient

    update

    global image_title \
	horizontal_size \
	vertical_size \
	number_of_chromosomes \
	chrmsmArray \
	source_file \
	lab_name \
	manual_correction \
	annotation_status
    ###############################
    # READ INPUT FILE (RUN SETUP) #
    ###############################
    Read_RunSetup

    ##############################################
    set genes_coord_file "html_image_map_coord.txt"
    set gene_heart_file  "heart_of_gene_coord.txt"
    set wc_file "$source_file\.wc"

    ############################################
    set longestChr [expr ceil([FindLargest chrmsmArray $number_of_chromosomes])]
    ############################################
    # the margin of canvas
    set left_margin 20
    # left and right border for chromosomes
    set max_window [expr $horizontal_size - 2*$left_margin]

    # puts $horizontal_size
    # puts $left_margin
    # puts $max_window

    ####################################
    #    define one MB in pixels       #
    ####################################
    #
    # PROBLEM: max_window MUST BE GREATER THAN longestChr
    # set one_mb [expr int(round($max_window/$longestChr))]
    # TRYING TO SOLVE THE PROBLEM
    # one_mb IS NOT AN INTEGER ANYMORE
    set one_mb [expr ($max_window*1.000000)/$longestChr]

    puts "One MBase in pixels: $one_mb"

    unset horizontal_size
    set horizontal_size [expr $one_mb*$longestChr + 2*$left_margin]

    # puts $horizontal_size 
    set horizontal_size [expr int(round($horizontal_size))]

    puts "Recalculated horizontal size: $horizontal_size"
    puts "-----------------------------------------------"
    ####################################
    #    chromosomes base position     #
    ####################################
    set chromosome_base_division [expr $vertical_size/($number_of_chromosomes + 1)]
    set ruler_space 12

    #########################################
    # how "fat" chromosomes are (in pixels) #
    #########################################
    global fat_chr
    # set fat_chr 5

    ######################################
    #  size of gene on screen in pixels  #
    ######################################
    global size_of_gene
    # set size_of_gene 9

    ####################################
    #   the percentage of similarity   #
    ####################################
    global loBound
    global upBound
    set loSimtyBound [expr $loBound * 0.01] ; # 0.01 BECAUSE INPUT FILE CONTAINS
    set upSimtyBound [expr $upBound * 0.01] ; #  NORMALIZED DATA BETWEEN 0 AND 1

    file delete -force $genes_coord_file    ; # TEMPORARY FILES
    file delete -force $gene_heart_file     ; # TO REDUCE COMPUTER
    file delete -force $wc_file             ; # MEMORY USAGE

    ############################################
    #        create scrolled canvas            #
    ############################################

    set scrollmax_x [expr $horizontal_size + 20]
    set scrollmax_y [expr $vertical_size + 20]

    global canvas_background \
	font_color_canvas

    Scrolled_Canvas .genpix -width 700 -height 500 \
	            -scrollregion "0 0 $scrollmax_x $scrollmax_y" -bg $canvas_background

    .genpix.canvas create rect 0 0 $scrollmax_x $scrollmax_y \
	    -fill $canvas_background -outline $canvas_background -tag "dummy_background"
    update

    Show_Gene_ID
    ############################################################
    # Banner and Credits on Canvas
    ############################################################
    set credits_banner_y [expr $vertical_size - 2]
    .genpix.canvas create text 6 $credits_banner_y -fill $font_color_canvas \
    -text "$image_title  $lab_name" -anchor sw -tag "this_is_a_text"

    set credits_on_canvas "Created with GenomePixelizer"

    set banner_length_right 180
    set credits_banner_x [expr $horizontal_size - $banner_length_right]
    .genpix.canvas create text $credits_banner_x $credits_banner_y -fill $font_color_canvas \
    -text $credits_on_canvas -anchor sw -tag "this_is_a_text"
    ############################################################

    # if {$one_mb >= 1} {}
    if {$one_mb >= 0} {

	DrawRuler chrmsmArray $one_mb $left_margin $longestChr

	for {set chromCounter 0} {$chromCounter < $number_of_chromosomes} {incr chromCounter} {
	    set chr_pixels [expr $chrmsmArray($chromCounter)*$one_mb]
	    DrawChromosome chrmsmArray $one_mb $fat_chr       \
		$chromosome_base_division          \
		$ruler_space $chromCounter         \
		$chr_pixels $left_margin           \
		$longestChr $number_of_chromosomes \
		$genes_coord_file $gene_heart_file \
		$manual_correction
	}

	############################################
	#    DRAW LINES CONNECTED RELATED GENES    # 
	############################################
	ShowMatchingPairs $upSimtyBound $loSimtyBound 
	############################################
	#       DEFINE AREA FOR SCREENSHOT         #
	############################################
	Html_ScreenShot $horizontal_size $vertical_size

	Canvas_Html_Size $horizontal_size $vertical_size $genes_coord_file

	if {$annotation_status == "TRUE"} {
	    Load_Annotation
	    Annot_Window
	}

	focus .genpix.canvas

	End_Be_Patient
	bell
	# Show_Gene_ID
    } else {
	set error_text1 "X-dimension in pixels must be greater than LONGEST CHROMOSOME"
	set error_text2 "You need to normalize data or increase X canvas dimension"
	puts $error_text1
	puts $error_text2
	.genpix.canvas create text 50 50 -fill $font_color_canvas \
	    -text $error_text1 -anchor sw
	.genpix.canvas create text 50 80 -fill $font_color_canvas \
	    -text $error_text2 -anchor sw
	End_Be_Patient
	destroy .idlabel
    }
}

##############################################
#        LOAD ANNOTATION PROCEDURE           #
##############################################
proc Load_Annotation {} {
    global annotation_file
    puts "... Loading Annotation ..."
    
    global annotation_file
    global annotation_array

    set annot_fp [open $annotation_file]

    set counter 1

    while { [gets $annot_fp line] >= 0 } {

	if { [string equal $line ""] } {
	    continue ; # if empty line, skip it
	}

	set sep	"\t"
	set gene [lindex [split $line $sep] 0]
	set annot [lindex [split $line $sep] 1]

	# puts "$counter  -=-  $gene"
	incr counter
	# update
	set annotation_array($gene) $annot
    }
    puts " "
    puts "$counter genes with annotation loaded"
    puts " "
    close $annot_fp
}

# =====================================================

proc Annot_Window {} {

    global keyword_search
    set keyword_search "search by keyword"

    destroy .annot_text
    toplevel .annot_text
    # wm transient .annot_text .canvasWin.canvasFrame.canvas
    wm title .annot_text "Annotation"
    wm minsize .annot_text 500 200
    # wm maxsize .annot_text 500 200
    wm protocol .annot_text WM_DELETE_WINDOW "destroy .annot_text"

    eval {text .annot_text.info -wrap word -bg "white" \
           -xscrollcommand [list .annot_text.xscroll set] \
           -yscrollcommand [list .annot_text.yscroll set]}
    scrollbar .annot_text.xscroll -orient horizontal \
              -command [list .annot_text.info xview]
    scrollbar .annot_text.yscroll -orient vertical \
              -command [list .annot_text.info yview]
    grid .annot_text.info .annot_text.yscroll -sticky news
    grid .annot_text.xscroll -sticky news
    grid rowconfigure .annot_text 0 -weight 1
    grid columnconfigure .annot_text 0 -weight 1

    entry .annot_text.entry_search -bg lightgreen -width 42 -textvariable keyword_search
    grid .annot_text.entry_search
    bind .annot_text.entry_search <Return> {Search_by_Keyword $keyword_search}
}

proc Search_by_Keyword { keyword_search } {

    global annotation_array
    global abc_tag
    global graph_fill_color
    global graph_outline_color

    puts $keyword_search

    set pattern_find "FALSE"

    set is_it_here1 [winfo exists .c_editor]
    if {$is_it_here1 == "0"} {
        Canvas_Editor
    }

    set is_it_there1 [winfo exists .annot_text]
    if {$is_it_there1 == "0"} {
        Annot_Window
    }

    .annot_text.info delete 1.0 end
    .annot_text.info insert end " --- Results of Search by Keyword: $keyword_search --- \n"

    foreach { gene annotation } [array get annotation_array] {
	set match_query [string match -nocase "*$keyword_search\*" $annotation]
	# puts "$gene\t$annotation"
	if { $match_query == 1 } {
	    set pattern_find "TRUE"
	    # puts "$gene\t$annotation"
	    set canvas_query [.genpix.canvas find withtag $abc_tag$gene]
	    if { $canvas_query != "" } {
		puts "$gene\t$annotation"
		.annot_text.info insert end "$gene\t$annotation\n"
		.genpix.canvas itemconfigure $abc_tag$gene -fill $graph_fill_color -outline $graph_outline_color
		# .genpix.canvas raise $abc_tag$gene
		update
	    }
	}
    }

    if { $pattern_find == "FALSE" } {
	puts "No match for $keyword_search"
	.annot_text.info insert end " --- No match --- \n"
    }
    bell
}

################################################################
#        END OF Genome_Pixelizer_Canvas PROCEDURE              #
#                                                              #
################################################################
################################################################

proc Be_Patient {} {
    destroy .patient
    set be_patient_text "be patient, processing data"
    toplevel .patient
    wm transient .patient .
    wm title .patient "be patient"
    wm protocol .patient WM_DELETE_WINDOW "destroy .patient"
    label .patient.text -text $be_patient_text -justify center -bg orange
    pack .patient.text -padx 12 -pady 12 
}

proc End_Be_Patient {} {
    destroy .patient
}

####################
#  GENE ID WINDOW  #
####################
proc Show_Gene_ID {} {

    destroy .idlabel
    toplevel .idlabel
    wm transient .idlabel .genpix
    wm title .idlabel "Gene ID"
    wm protocol .idlabel WM_DELETE_WINDOW "destroy .idlabel"
    label .idlabel.label -text "Gene ID:" -justify right -bg gray
    entry .idlabel.geneid -relief sunken -textvariable geneName -bg lightblue
    pack .idlabel.label .idlabel.geneid -side left -padx 3 -pady 3
    bind .idlabel.geneid <Return> {highLightGene .genpix.canvas $geneName}
}

####################### FindLargest #####################
#                       -----------                     #
#  This procedure finds the largest element in the list #
#  (we'll use it later to find the largest chromosome)  #
#########################################################

proc FindLargest  {someArray quantity} {
    upvar $someArray array 
    set largest $array(0)
    puts "FIND LARGEST"
    for {set i 0} {$i < [expr $quantity - 0]} {incr i} {
	if {$largest < $array($i)} {
	    set largest $array($i)
	    puts "$array($i) CURRENT CHRM"
	}
    }
    puts "LARGEST IS: $largest"
    # after 2000
    return $largest
}

####################### DrawRuler #######################
#                       ---------                       #
#   This procedure uses the the length of the longest   #
#   chromosome to draw the ruler and uses "RulerLabel"  #
#   procedure to draw text labels on the ruler.         #
#########################################################

proc DrawRuler {someArray one_mb left_margin longestChromosome} {

    global font_color_canvas

    set longestChr   [expr ceil($longestChromosome)]
    set chr_pixels   [expr $longestChr*$one_mb]
    set ruler_length [expr $chr_pixels + $left_margin]

    .genpix.canvas create line [expr $left_margin - 1] 17 \
	[expr $ruler_length + 1] 17 -width 2 -fill $font_color_canvas -tag "this_is_a_ruler"

    ########################################################
    # DIVIDE LONGEST CHROMOSOME ON 20 PARTS AND DRAW RULER #
    ########################################################
    set vertical_value [expr $longestChromosome/20.00]
    set vertical_bar_20 [expr $chr_pixels/20]
    set vertical_bar_20 [expr int(round($vertical_bar_20))]

    #########################################################
    #    IF CANVAS LESS THAN 2000 PIXELS PRINT 10 LABELS    #
    #########################################################
    set mod_value 2
    #########################################################
    #  IF CANVAS MORE THAN 2000 PIXELS PRINT ALL 20 LABELS  #
    #########################################################
    if {$chr_pixels >= 2000} {
	set mod_value 1
    }
    ###############################
    #   20 LABELS ON THE RULER    #
    ###############################
    set i 0
    while {$i <= 20} {
	.genpix.canvas create line [expr ($i*$vertical_bar_20 + $left_margin)] 17 \
	    [expr ($i*$vertical_bar_20 + $left_margin)] 23 -width 2 -fill $font_color_canvas \
	    -tag "this_is_a_ruler"
	set even_test [expr fmod($i, $mod_value)]
	#############################
	#      FIRST 19 LABELS      #
	#############################
	if {$even_test == 0 && $i <= 19} {
	    .genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 10] 17 \
		-text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	}
	#############################
	# LAST LABEL AT POSITION 20 #
	#############################
	if {$even_test == 0 && $i == 20} {
	    if {[expr $i*$vertical_value] < 1000} {
		.genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 15] 17 \
		    -text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	    }
	    if {[expr $i*$vertical_value] >= 1000 && [expr $i*$vertical_value] < 10000} {
		.genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 25] 17 \
		    -text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	    }
	    if {[expr $i*$vertical_value] >= 10000 && [expr $i*$vertical_value] < 100000} {
		.genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 35] 17 \
		    -text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	    }
	    if {[expr $i*$vertical_value] >= 100000 && [expr $i*$vertical_value] < 1000000} {
		.genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 45] 17 \
		    -text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	    }
	    if {[expr $i*$vertical_value] >= 1000000} {
		.genpix.canvas create text [expr ($i*$vertical_bar_20 + $left_margin) - 55] 17 \
		    -text [expr $i*$vertical_value] -fill $font_color_canvas -anchor sw -tag "this_is_a_text"
	    }
	}
	puts "$i\t$vertical_bar_20\t[expr $i*$vertical_bar_20]"
	incr i
	update
    }
}

####################################
#                                  #
#    DRAW CHROMOSOMES ON CANVAS    #
#                                  #
####################################

proc DrawChromosome {someArray one_mb fat_chr \
	             chromosome_base_division \
		     ruler_space i chr_pixels \
		     left_margin longestChr   \
		     number_of_chromosomes    \
		     genes_coord_file gene_heart_file manual_correction} {

    global chromosome_color \
	chromosome_outline \
	low_base_chr \
	gene_feature_mode

     set base_chr [expr [expr $i + 1]*$chromosome_base_division + $ruler_space - 6 ]
     ### correction because of "credits banner" at bottom -----------------------^
     set low_base_chr [expr $base_chr + $fat_chr]
     #
     # adjusted values for chromosomes 
     # physical address has to be shifted to the right because of left margin
     #
     set chr_pixels_adj [expr $chr_pixels + $left_margin]
     #
     # now draw chromosomes
     #
     .genpix.canvas create rect $left_margin $base_chr \
      $chr_pixels_adj $low_base_chr -fill $chromosome_color -outline $chromosome_outline -tag "chromosome_tag"
     #
     ####################################
     #    Draw genes on Chromosomes     #
     ####################################
    if {$gene_feature_mode == "std"} {
	DrawGenes_Std $one_mb $left_margin $i $base_chr  \
	    $number_of_chromosomes $longestChr \
	    $genes_coord_file $gene_heart_file $manual_correction
    }
    if {$gene_feature_mode == "ext"} {
	DrawGenes_Ext $one_mb $left_margin $i $base_chr  \
	    $number_of_chromosomes $longestChr \
	    $genes_coord_file $gene_heart_file $manual_correction
    }
}

###############Draw Genes###################
#	       ----------                  #
#  Procedure Draw genes on Chromosomes     #
#                                          #
############################################
# STANDARD
proc DrawGenes_Std {one_mb left_margin i base_chr    \
			number_of_chromosomes longestChr \
			genes_coord_file gene_heart_file manual_correction} {
	
    global size_of_gene source_file wc_file \
	vertical_size_of_gene wc_coefficient \
	wc_corr_value low_base_chr abc_tag

    ####################################################
    #  Switch for  Manual or Automatic W/C correction  #
    #          M/m-manual, A/a - automatic             #
    ####################################################

    #############################
    # read data from input file #
    #############################
    set gene_data [open $source_file]

    #########################################################
    # we will put the same information that is in the input #
    # file <filename> into the file <filename-WC> plus we   #
    # will add an extra column with w/c correction          #
    #########################################################
    if {$manual_correction == "A"} {
	set wc_file "$source_file.\wc"
	set test [open "$wc_file" "a"]
    }

    set k 0
    set l 0
    set m 0
    while {[gets $gene_data current_line] >= 0 } {
	set chr_number [lindex $current_line 0]
	if {$chr_number == [expr $i + 1]} { 
	    set gene_id  [lindex $current_line 1]
	    set gene_coordinates_mb($k) [lindex [split $current_line] 2]
	    set gene_coordinates_pixels_float [expr $gene_coordinates_mb($k)*$one_mb + $left_margin]
	    ######################################--------------------------------------^^^^^^^^^^^
	    ############################################### adjustment because of left margin
	    # ROUNDING TO INTEGER:
	    set gene_coordinates_pixels [expr int(round($gene_coordinates_pixels_float))]

	    #adjustment (shifting gene to the left on distance of 1/2 size_of_gene)
	    #(it is really dummy adjustment too :)
	    set shift_me_to_the_left [expr $size_of_gene/2]
	    # gene feature_a (WATSON/CRICK ORIENTATION)
	    set gene_feature_a [lindex [split $current_line] 3]
	    # gene feature_b (GENE FEATURE COLOR)
	    set gene_feature_b [lindex [split $current_line] 4]
	    set gene_color [AssignColor $gene_feature_b]
	    set outline_gene_color [AssignBorder $gene_feature_b]
	    ###############################################################################
	    #################### COOL WHEN UNCOMMENTED ! ##################################
	    #	        set outline_gene_color [AssignColor $gene_feature_b]
	    ###############################################################################
	    if {$manual_correction == "M" || $manual_correction == "m"} {

		# puts "MANUAL!!!"
		set wc_correction [lindex [split $current_line] 5]		
		set wc_temp($k) [expr $gene_coordinates_mb($k) * $one_mb ]

		# Watson on top
		if {$gene_feature_a == "W"} {
		    # base coordinates
		    set gene_base_chr [expr ($base_chr - 2 - \
						 $wc_correction*$wc_coefficient*$wc_corr_value)]
		    set gene_upper_base_chr [expr $gene_base_chr - $vertical_size_of_gene]
		}

		# Crick on bottom
		if {$gene_feature_a == "C"} {
		    # base coordinates
		    set gene_upper_base_chr [expr ($low_base_chr + 2 + \
						       $wc_correction*$wc_coefficient*$wc_corr_value)]
		    set gene_base_chr [expr ($gene_upper_base_chr + $vertical_size_of_gene)]
		}

		###################################################
		set current_gene_coordinates [expr $gene_coordinates_pixels \
						  - $shift_me_to_the_left]
		set gene_length [expr $current_gene_coordinates + $size_of_gene]
		############### size of gene on screen in pixels--^^^^^^^^^^^^^

		.genpix.canvas create rect $current_gene_coordinates \
		    $gene_upper_base_chr      \
		    $gene_length              \
		    $gene_base_chr            \
		    -fill $gene_color -outline $outline_gene_color -tag $abc_tag$gene_id
		.genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		.genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		.genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		.genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		.genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id" 
		.genpix.canvas bind $abc_tag$gene_id <Enter> {
		    set curX [expr int(round([.genpix.canvas canvasx %x]))]
		    set curY [expr int(round([.genpix.canvas canvasy %y]))]
		}

		GetCoordinates $current_gene_coordinates \
		    $gene_length $gene_base_chr \
		    $gene_upper_base_chr        \
		    $gene_id $base_chr $i       \
		    $genes_coord_file $gene_heart_file 
		update
	    } else {
		# puts "AUTOMATIC - DEFAULT!!!"
		# Watson on top
		if {$gene_feature_a == "W"} {
		    set w_array($l) $gene_coordinates_mb($k)
		    set wc_temp($l) [expr $w_array($l) * $one_mb]
	
		    if {$l == 0} {
			set wc_correction($l) 0
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$wc_correction($l)"

		    } else {
			set wc_temp2($l) [expr $wc_temp($l) - $wc_temp([expr $l - 1])]	
			set wc_correction($l) [WC_Correction  $wc_temp2($l)]

			if {$wc_correction($l) > 0 && $wc_correction([expr $l - 1])> 0} {
			    set wc_correction($l) [expr $wc_correction($l) + \
						       $wc_correction([expr $l - 1])]
			}
		
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$wc_correction($l)"
		    }	

		    set gene_base_chr [expr ($base_chr - 2 - \
						 $wc_correction($l)*$wc_coefficient*$wc_corr_value)]
		    set gene_upper_base_chr [expr $gene_base_chr - $vertical_size_of_gene]

		    ###################################################
		    set current_gene_coordinates [expr $gene_coordinates_pixels \
						      - $shift_me_to_the_left]
		    set gene_length [expr $current_gene_coordinates + $size_of_gene]
		    ############### size of gene on screen in pixels--^^^^^^^^^^^^^

		    .genpix.canvas create rect $current_gene_coordinates \
			$gene_upper_base_chr        \
			$gene_length                \
			$gene_base_chr              \
			-fill $gene_color -outline $outline_gene_color -tag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		    .genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		    .genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		    .genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id" 
		    .genpix.canvas bind $abc_tag$gene_id <Enter> {
			set curX [expr int(round([.genpix.canvas canvasx %x]))]
			set curY [expr int(round([.genpix.canvas canvasy %y]))]
		    }

		    GetCoordinates $current_gene_coordinates   \
			$gene_length $gene_base_chr \
			$gene_upper_base_chr        \
			$gene_id $base_chr $i       \
			$genes_coord_file $gene_heart_file 
		    incr l 	
		} 
		
		update

		#Crick on bottom
		if {$gene_feature_a == "C"} {
		    set c_array($m) $gene_coordinates_mb($k)
		    set wc_temp($m) [expr $c_array($m) * $one_mb]

		    if {$m == 0} {
			set wc_correction($l) 0
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$wc_correction($l)"
		    } else {
			set wc_temp2($m) [expr $wc_temp($m) - $wc_temp([expr $m - 1])]	
			set wc_correction($m) [WC_Correction  $wc_temp2($m)]

			if {$wc_correction($m) > 0 && $wc_correction([expr $m - 1])> 0} {
			    set wc_correction($m) [expr $wc_correction($m) \
						       + $wc_correction([expr $m - 1])]
			}
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$wc_correction($m)"
		    }	

		    # base coordinates
		    set gene_upper_base_chr [expr ($low_base_chr + 2 + \
						       $wc_correction($m)*$wc_coefficient*$wc_corr_value)]
		    set gene_base_chr [expr ($gene_upper_base_chr + $vertical_size_of_gene)]

		    ###################################################
		    set current_gene_coordinates [expr \
						      $gene_coordinates_pixels - $shift_me_to_the_left]
		    set gene_length [expr $current_gene_coordinates + $size_of_gene]
		    ############### size of gene on screen in pixels--^^^^^^^^^^^^^

			
		    .genpix.canvas create rect $current_gene_coordinates   \
			$gene_upper_base_chr        \
			$gene_length                \
			$gene_base_chr              \
			-fill $gene_color \
			-outline $outline_gene_color -tag $abc_tag$gene_id 
		    .genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		    .genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		    .genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		    .genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id" 
		    .genpix.canvas bind $abc_tag$gene_id <Enter> {
			set curX [expr int(round([.genpix.canvas canvasx %x]))]
			set curY [expr int(round([.genpix.canvas canvasy %y]))]
		    }

		    GetCoordinates $current_gene_coordinates   \
			$gene_length $gene_base_chr \
			$gene_upper_base_chr        \
			$gene_id $base_chr $i       \
			$genes_coord_file $gene_heart_file 
		    incr m
		} 
		update
	    }
	}
	incr k
    }
    if {$manual_correction == "A"} {			
	close $test
    }
    close $gene_data
}

#######################################################
# EXTENDED
proc DrawGenes_Ext {one_mb left_margin i base_chr    \
			number_of_chromosomes longestChr \
			genes_coord_file gene_heart_file manual_correction} {

    global size_of_gene source_file wc_file \
	vertical_size_of_gene wc_coefficient \
	wc_corr_value low_base_chr size_of_gene_current abc_tag

    ####################################################
    #  Switch for  Manual or Automatic W/C correction  #
    #          M/m-manual, A/a - automatic             #
    ####################################################

    #############################
    # read data from input file #
    #############################
    set gene_data [open $source_file]

    #########################################################
    # we will put the same information that is in the input #
    # file <filename> into the file <filename-WC> plus we   #
    # will add an extra column with w/c correction          #
    #########################################################
    if {$manual_correction == "A"} {
	set wc_file "$source_file.\wc"
	set test [open "$wc_file" "a"]
    }

    set k 0
    set l 0
    set m 0
    while {[gets $gene_data current_line] >= 0 } {
	set chr_number [lindex $current_line 0]
	if {$chr_number == [expr $i + 1]} { 
	    set gene_id    [lindex $current_line 1]
	    set gene_coordinates_mb($k) [lindex [split $current_line] 2]
	    set gene_coordinates_pixels_float [expr $gene_coordinates_mb($k)*$one_mb + $left_margin]
	    ######################################--------------------------------------^^^^^^^^^^^
	    ############################################### adjustment because of left margin
	    # ROUNDING TO INTEGER:
	    set gene_coordinates_pixels [expr int(round($gene_coordinates_pixels_float))]

	    # gene feature_a
	    set gene_feature_a [lindex [split $current_line] 3]
	    # gene feature_b
	    set gene_feature_b [lindex [split $current_line] 4]
	    set gene_feature_c($k) [lindex [split $current_line] 5]
	    set size_of_gene_coefficient($k) $gene_feature_c($k)
	    set size_of_gene_current($k) [expr $size_of_gene*$size_of_gene_coefficient($k)]
	    set gene_color [AssignColor $gene_feature_b]
	    set outline_gene_color [AssignBorder $gene_feature_b]
	    ###############################################################################
	    #################### COOL WHEN UNCOMMENTED ! ##################################
	    #	        set outline_gene_color [AssignColor $gene_feature_b]
	    ###############################################################################

	    #adjustment (shifting gene to the left on distance of 1/2 size_of_gene)
	    #(it is really dummy adjustment too :)
	    set shift_me_to_the_left($k) [expr $size_of_gene_current($k)/2]

	    if {$manual_correction == "M" || $manual_correction == "m"} {

		# puts "MANUAL!!!"
		set wc_correction [lindex [split $current_line] 6]		
		set wc_temp($k) [expr $gene_coordinates_mb($k) * $one_mb]

		# Watson on top
		if {$gene_feature_a == "W"} {
		    # base coordinates
		    set gene_base_chr [expr ($base_chr - 2 - \
						 $wc_correction*$wc_coefficient*$wc_corr_value)]
		    set gene_upper_base_chr [expr $gene_base_chr - $vertical_size_of_gene]
		}

		# Crick on bottom
		if {$gene_feature_a == "C"} {
		    # base coordinates
		    set gene_upper_base_chr [expr ($low_base_chr + 2 + \
						       $wc_correction*$wc_coefficient*$wc_corr_value)]
		    set gene_base_chr [expr ($gene_upper_base_chr + $vertical_size_of_gene)]
		}

		###################################################
		set current_gene_coordinates [expr $gene_coordinates_pixels \
						  - $shift_me_to_the_left($k)]
		set gene_length [expr $current_gene_coordinates + $size_of_gene_current($k)]
		####### current size of gene on screen in pixels--^^^^^^^^^^^^^^^^^^^^^^

		.genpix.canvas create rect $current_gene_coordinates \
		    $gene_upper_base_chr      \
		    $gene_length              \
		    $gene_base_chr            \
		    -fill $gene_color -outline $outline_gene_color -tag $abc_tag$gene_id
		.genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		.genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		.genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		.genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		.genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id" 
		.genpix.canvas bind $abc_tag$gene_id <Enter> {
		    set curX [expr int(round([.genpix.canvas canvasx %x]))]
		    set curY [expr int(round([.genpix.canvas canvasy %y]))]
		}

		GetCoordinates $current_gene_coordinates \
		    $gene_length $gene_base_chr \
		    $gene_upper_base_chr        \
		    $gene_id $base_chr $i       \
		    $genes_coord_file $gene_heart_file 
		update
	    } else {
		# puts "AUTOMATIC - DEFAULT!!!"
		# Watson on top
		if {$gene_feature_a == "W"} {
		    ########################################
		    set w_array_right($l) [expr $gene_coordinates_mb($k)*$one_mb \
					       + $shift_me_to_the_left($k)]
		    set w_array_left($l) [expr $gene_coordinates_mb($k)*$one_mb \
					      - $shift_me_to_the_left($k)]
		    ########################################
		    if {$l == 0} {
			set wc_correction($l) 0
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$gene_feature_c($k)\t$wc_correction($l)"

		    } else {	
			set wc_temp2($l) [expr $w_array_left($l) - $w_array_right([expr $l -1])]
			set wc_correction($l) [WC_Correction_Ext $wc_temp2($l)]

			if {$wc_correction($l) > 0 && $wc_correction([expr $l - 1])> 0} {
			    set wc_correction($l) [expr $wc_correction($l) + \
						       $wc_correction([expr $l - 1])]
			}

			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$gene_feature_c($k)\t$wc_correction($l)"
		    }	

		    set gene_base_chr [expr ($base_chr - 2 - \
						 $wc_correction($l)*$wc_coefficient*$wc_corr_value)]
		    set gene_upper_base_chr [expr $gene_base_chr - $vertical_size_of_gene]

		    ###################################################
		    set current_gene_coordinates [expr $gene_coordinates_pixels \
						      - $shift_me_to_the_left($k)]
		    set gene_length [expr $current_gene_coordinates + $size_of_gene_current($k)]
		    ####### current size of gene on screen in pixels--^^^^^^^^^^^^^^^^^^^^^^

		    .genpix.canvas create rect $current_gene_coordinates \
			$gene_upper_base_chr        \
			$gene_length                \
			$gene_base_chr              \
			-fill $gene_color -outline $outline_gene_color -tag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		    .genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		    .genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		    .genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id"
		    .genpix.canvas bind $abc_tag$gene_id <Enter> {
			set curX [expr int(round([.genpix.canvas canvasx %x]))]
			set curY [expr int(round([.genpix.canvas canvasy %y]))]
		    }

		    GetCoordinates $current_gene_coordinates   \
			$gene_length $gene_base_chr \
			$gene_upper_base_chr        \
			$gene_id $base_chr $i       \
			$genes_coord_file $gene_heart_file 
		    incr l 	
		} 

		update

		#Crick on bottom
		if {$gene_feature_a == "C"} {
		    ########################################
		    set w_array_right($m) [expr $gene_coordinates_mb($k)*$one_mb \
					       + $shift_me_to_the_left($k)]
		    set w_array_left($m) [expr $gene_coordinates_mb($k)*$one_mb \
					      - $shift_me_to_the_left($k)]
		    ########################################
		    if {$m == 0} {
			set wc_correction($l) 0
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$gene_feature_c($k)\t$wc_correction($l)"
		    } else {
			set wc_temp2($m) [expr $w_array_left($m) - $w_array_right([expr $m -1])]
			set wc_correction($m) [WC_Correction_Ext $wc_temp2($m)]

			if {$wc_correction($m) > 0 && $wc_correction([expr $m - 1])> 0} {
			    set wc_correction($m) [expr $wc_correction($m) \
						       + $wc_correction([expr $m - 1])]
			}
			puts -nonewline $test \
			    "$chr_number\t$gene_id\t$gene_coordinates_mb($k)\t$gene_feature_a\t"
			puts $test "$gene_feature_b\t$gene_feature_c($k)\t$wc_correction($m)"
		     }

		    # base coordinates
		    set gene_upper_base_chr [expr ($low_base_chr + 2 + \
						       $wc_correction($m)*$wc_coefficient*$wc_corr_value)]
		    set gene_base_chr [expr ($gene_upper_base_chr + $vertical_size_of_gene)]

		    ###################################################
		    set current_gene_coordinates [expr \
						      $gene_coordinates_pixels - $shift_me_to_the_left($k)]
		    set gene_length [expr $current_gene_coordinates + $size_of_gene_current($k)]
		    ####### current size of gene on screen in pixels--^^^^^^^^^^^^^^^^^^^^^^

		    .genpix.canvas create rect $current_gene_coordinates   \
			$gene_upper_base_chr        \
			$gene_length                \
			$gene_base_chr              \
			-fill $gene_color \
			-outline $outline_gene_color -tag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-1> "showName $gene_id .idlabel.geneid"
		    .genpix.canvas addtag "gene_tag" withtag $abc_tag$gene_id
		    .genpix.canvas addtag fill$gene_color withtag $abc_tag$gene_id
		    .genpix.canvas addtag outline$outline_gene_color withtag $abc_tag$gene_id
		    .genpix.canvas bind $abc_tag$gene_id <Button-2> "Print_Gene_ID $gene_id"
		    .genpix.canvas bind $abc_tag$gene_id <Enter> {
			set curX [expr int(round([.genpix.canvas canvasx %x]))]
			set curY [expr int(round([.genpix.canvas canvasy %y]))]
		    }

		    GetCoordinates $current_gene_coordinates   \
			$gene_length $gene_base_chr \
			$gene_upper_base_chr        \
			$gene_id $base_chr $i       \
			$genes_coord_file $gene_heart_file 
		    incr m
		}
		update
	    }
	}
	incr k
    }
    if {$manual_correction == "A"} {
	close $test
    }
    close $gene_data
}

###########################################
# W/C Correction for high density regions #
#                                         #
proc WC_Correction { data } {
	
    global size_of_gene

	if {$data > $size_of_gene} {
		return 0
	}
	if {$data <= $size_of_gene} { 
		return 1
	}
}

###########################################
# W/C Correction for high density regions #
#       EXTENDED                                  #
proc WC_Correction_Ext { data } {

	if {$data > 0} {
		return 0
	}
	if {$data <= 0} { 
		return 1
	}
}

#########################################
#    Draw genes in different color!     #
#                                       #
proc AssignColor {gene_feature_b} {

    global gene_color_black gene_color_blue gene_color_brown gene_color_cyan \
       gene_color_gold gene_color_gray gene_color_green gene_color_lightblue \
       gene_color_orange gene_color_pink gene_color_purple gene_color_salmon \
       gene_color_red gene_color_violet gene_color_white gene_color_yellow \
       outline_gene_color

	if {$gene_feature_b == "black"} {
	    set gene_color $gene_color_black
	    return $gene_color
	}		
	if {$gene_feature_b == "blue"} {
	    set gene_color $gene_color_blue
	    return $gene_color
	}
	if {$gene_feature_b == "brown"} {
	    set gene_color $gene_color_brown
	    return $gene_color
	}
	if {$gene_feature_b == "cyan"} {
	    set gene_color $gene_color_cyan
	    return $gene_color
	}
	if {$gene_feature_b == "gold"} {
	    set gene_color $gene_color_gold
	    return $gene_color
	}
	if {$gene_feature_b == "gray"} {
	    set gene_color $gene_color_gray
	    return $gene_color
	}
	if {$gene_feature_b == "green"} {
	    set gene_color $gene_color_green
	    return $gene_color
	}
	if {$gene_feature_b == "lightblue"} {
	    set gene_color $gene_color_lightblue
	    return $gene_color
	}
	if {$gene_feature_b == "orange"} {
	    set gene_color $gene_color_orange
	    return $gene_color
	}
	if {$gene_feature_b == "pink"} {
	    set gene_color $gene_color_pink
	    return $gene_color
	}
	if {$gene_feature_b == "purple"} {
	    set gene_color $gene_color_purple
	    return $gene_color
	}
	if {$gene_feature_b == "red"} {
	    set gene_color $gene_color_red
	    return $gene_color
	}
	if {$gene_feature_b == "salmon"} {
	    set gene_color $gene_color_salmon
	    return $gene_color
	}
	if {$gene_feature_b == "violet"} {
	    set gene_color $gene_color_violet
	    return $gene_color
	}
	if {$gene_feature_b == "white"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "yellow"} {
	    set gene_color $gene_color_yellow
	    return $gene_color
	}
    ################################################
    #             COMPLEX COLORS                   #
    ################################################
	if {$gene_feature_b == "gold_cyan"} {
	    set gene_color $gene_color_gold
	    return $gene_color
	}
	if {$gene_feature_b == "brown_gold"} {
	    set gene_color $gene_color_brown
	    return $gene_color
	}
	if {$gene_feature_b == "white_gray"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "white_gold"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "white_red"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "white_blue"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "white_green"} {
	    set gene_color $gene_color_white
	    return $gene_color
	}
	if {$gene_feature_b == "yellow_red"} {
	    set gene_color $gene_color_yellow
	    return $gene_color
	}
	if {$gene_feature_b == "yellow_blue"} {
	    set gene_color $gene_color_yellow
	    return $gene_color
	}
	if {$gene_feature_b == "yellow_green"} {
	    set gene_color $gene_color_yellow
	    return $gene_color
	}
	if {$gene_feature_b == "black_red"} {
	    set gene_color $gene_color_black
	    return $gene_color
	}
	if {$gene_feature_b == "black_orange"} {
	    set gene_color $gene_color_black
	    return $gene_color
	}
	if {$gene_feature_b == "black_cyan"} {
	    set gene_color $gene_color_black
	    return $gene_color
	}
	if {$gene_feature_b == "black_green"} {
	    set gene_color $gene_color_black
	    return $gene_color
	}
	if {$gene_feature_b == "blue_green"} {
	    set gene_color $gene_color_blue
	    return $gene_color
	}
	if {$gene_feature_b == "blue_orange"} {
	    set gene_color $gene_color_blue
	    return $gene_color
	}
	if {$gene_feature_b == "orange_red"} {
	    set gene_color $gene_color_orange
	    return $gene_color
	}
	if {$gene_feature_b == "orange_blue"} {
	    set gene_color $gene_color_orange
	    return $gene_color
	}
	if {$gene_feature_b == "orange_purple"} {
	    set gene_color $gene_color_orange
	    return $gene_color
	}
	if {$gene_feature_b == "cyan_red"} {
	    set gene_color $gene_color_cyan
	    return $gene_color
	}
	if {$gene_feature_b == "cyan_blue"} {
	    set gene_color $gene_color_cyan
	    return $gene_color
	}
	if {$gene_feature_b == "cyan_green"} {
	    set gene_color $gene_color_cyan
	    return $gene_color
	}
	if {$gene_feature_b == "lightblue_blue"} {
	    set gene_color $gene_color_lightblue
	    return $gene_color
	}
	if {$gene_feature_b == "gray_blue"} {
	    set gene_color $gene_color_gray
	    return $gene_color
	}
	if {$gene_feature_b == "gray_red"} {
	    set gene_color $gene_color_gray
	    return $gene_color
	}
	if {$gene_feature_b == "green_blue"} {
	    set gene_color $gene_color_green
	    return $gene_color
	}
	if {$gene_feature_b == "green_red"} {
	    set gene_color $gene_color_green
	    return $gene_color
	}
	if {$gene_feature_b == "green_gold"} {
	    set gene_color $gene_color_green
	    return $gene_color
	}
	if {$gene_feature_b == "violet_purple"} {
	    set gene_color $gene_color_violet
	    return $gene_color
	}
	if {$gene_feature_b == "violet_blue"} {
	    set gene_color $gene_color_violet
	    return $gene_color
	}
	if {$gene_feature_b == "violet_red"} {
	    set gene_color $gene_color_violet
	    return $gene_color
	}
	if {$gene_feature_b == "pink_red"} {
	    set gene_color $gene_color_pink
	    return $gene_color
	}
	if {$gene_feature_b == "pink_purple"} {
	    set gene_color $gene_color_pink
	    return $gene_color
	} else {
	    Color_Error_Report
	    update
	    destroy .genpix
	    destroy .patient
	}
}

proc AssignBorder {gene_feature_b} {

    global gene_color_black gene_color_blue gene_color_brown gene_color_cyan \
       gene_color_gold gene_color_gray gene_color_green gene_color_lightblue \
       gene_color_orange gene_color_pink gene_color_purple gene_color_salmon \
       gene_color_red gene_color_violet gene_color_white gene_color_yellow 

    global outline_gene_color default_outline_gene_color

    set outline_gene_color "$default_outline_gene_color"

	if {$gene_feature_b == "gold_cyan"} {
	    set outline_gene_color $gene_color_cyan
	    return $outline_gene_color
	}
	if {$gene_feature_b == "brown_gold"} {
	    set outline_gene_color $gene_color_gold
	    return $outline_gene_color
	}
	if {$gene_feature_b == "white_gray"} {
	    set outline_gene_color $gene_color_gray
	    return $outline_gene_color
	}
	if {$gene_feature_b == "white_gold"} {
	    set outline_gene_color $gene_color_gold
	    return $outline_gene_color
	}
	if {$gene_feature_b == "white_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "white_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "white_green"} {
	    set outline_gene_color $gene_color_green
	    return $outline_gene_color
	}
	if {$gene_feature_b == "yellow_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "yellow_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "yellow_green"} {
	    set outline_gene_color $gene_color_green
	    return $outline_gene_color
	}
	if {$gene_feature_b == "black_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "black_orange"} {
	    set outline_gene_color $gene_color_orange
	    return $outline_gene_color
	}
	if {$gene_feature_b == "black_cyan"} {
	    set outline_gene_color $gene_color_cyan
	    return $outline_gene_color
	}
	if {$gene_feature_b == "black_green"} {
	    set outline_gene_color $gene_color_green
	    return $outline_gene_color
	}
	if {$gene_feature_b == "blue_green"} {
	    set outline_gene_color $gene_color_green
	    return $outline_gene_color
	}
	if {$gene_feature_b == "blue_orange"} {
	    set outline_gene_color $gene_color_orange
	    return $outline_gene_color
	}
	if {$gene_feature_b == "orange_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "orange_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "orange_purple"} {
	    set outline_gene_color $gene_color_purple
	    return $outline_gene_color
	}
	if {$gene_feature_b == "cyan_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "cyan_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "cyan_green"} {
	    set outline_gene_color $gene_color_green
	    return $outline_gene_color
	}
	if {$gene_feature_b == "lightblue_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "gray_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "gray_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "green_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "green_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "green_gold"} {
	    set outline_gene_color $gene_color_gold
	    return $outline_gene_color
	}
	if {$gene_feature_b == "violet_purple"} {
	    set outline_gene_color $gene_color_purple
	    return $outline_gene_color
	}
	if {$gene_feature_b == "violet_blue"} {
	    set outline_gene_color $gene_color_blue
	    return $outline_gene_color
	}
	if {$gene_feature_b == "violet_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "pink_red"} {
	    set outline_gene_color $gene_color_red
	    return $outline_gene_color
	}
	if {$gene_feature_b == "pink_purple"} {
	    set outline_gene_color $gene_color_purple
	    return $outline_gene_color
	} else {
	    set outline_gene_color "$default_outline_gene_color"
	}
    }

proc Color_Error_Report {} {

    destroy .color_error
    set bart_image [image create photo -height 58 -width 46 \
    -file ./Images/bart.gif]
    set color_error_text \
"Sorry, one of gene feature colors
from your input file is not defined 
in current version of GenomePixelizer. 
Please, re-check your input file."
    toplevel .color_error
    wm title .color_error "Error Report"
    wm protocol .color_error WM_DELETE_WINDOW "destroy .color_error"
    label .color_error.image -image $bart_image
    label .color_error.text -text $color_error_text -justify center
    button .color_error.dismiss -text "Dismiss" -command {destroy .color_error}
    pack .color_error.image -padx 7 -pady 7
    pack .color_error.text -padx 2 -pady 2
    pack .color_error.dismiss -padx 2 -pady 2

}

##################### Get Coordinates ##########################################
#                                                                              #
#       These coordinates are used for mouse-over events on canvas and         #
#                     generation of ImageMap HTML file                         #
#                                                                              #
################################################################################
proc GetCoordinates {current_gene_coordinates  gene_length \
			 gene_base_chr  gene_upper_base_chr    \
			 gene_id base_chr i genes_coord_file gene_heart_file} {
	 
     # HTML image map coordinates file output
     set html_out [open $genes_coord_file "a"]

     # "heart of gene" temporary file output
     set heart_out [open $gene_heart_file "a"]

     PutCoordinates $current_gene_coordinates  $gene_length \
	   	    $gene_base_chr  $gene_upper_base_chr    \
		    $gene_id base_chr $html_out $heart_out
	
     close $html_out
     close $heart_out

}

proc PutCoordinates {current_gene_coordinates  gene_length \
			 gene_base_chr  gene_upper_base_chr    \
			 gene_id base_chr html_out heart_out} {
        
     global http_prefix 

     # place coordinates for html image map
     puts -nonewline $html_out "<AREA SHAPE=\"RECT\" COORDS=\""
     puts -nonewline $html_out "$current_gene_coordinates, "
     puts -nonewline $html_out "$gene_upper_base_chr, "
     puts -nonewline $html_out "$gene_length, "
     puts -nonewline $html_out "$gene_base_chr\" "
     puts -nonewline $html_out "HREF=\""
     puts -nonewline $html_out "$http_prefix$gene_id\""
     puts -nonewline $html_out " TARGET=\"_blank\""
     puts -nonewline $html_out " TITLE=\"$gene_id\""
     puts -nonewline $html_out ">\n"

     # calculation of the center of current gene
     set gene_heart_coord_x [expr ($current_gene_coordinates + $gene_length)/2]
     set gene_heart_coord_y [expr ($gene_upper_base_chr + $gene_base_chr)/2]

     # place coords of "heart of gene"
     puts -nonewline $heart_out "$gene_id\t"
     puts -nonewline $heart_out "$gene_heart_coord_x\t"
     puts -nonewline $heart_out "$gene_heart_coord_y\n"

}

################################################
#   Matching pairs from Distance matrix file   #
################################################
proc ShowMatchingPairs {upSimtyBound loSimtyBound} { 

    global matrix_file default_familyColor

    set f_in [open "$matrix_file"  "r"]

    # DELETE TEMPORARY FILE WITH LINE COORDINATES #
    file delete -force "line_coordinates.txt"

    set searchfile "heart_of_gene_coord.txt"
    set f_search [open "$searchfile"  "r"]

    ###########################
    # READ CANVAS COORDS FILE #
    ###########################
    set i 0
    set gene_list ""
    while {[gets $f_search searchItem] >= 0 } {	
	set curr_seqs              [lindex [split $searchItem] 0]
	set already_done           [lsearch -exact $gene_list $curr_seqs]
	# SEARCH FOR DUPLICATED IDs #
	if {$already_done < 0} {
	    set gene_list [lappend gene_list $curr_seqs]
	    set curr_coordX($curr_seqs) [lindex [split $searchItem] 1]
	    set curr_coordY($curr_seqs) [lindex [split $searchItem] 2]
	}
	# SEARCH FOR DUPLICATED IDs #
	if {$already_done >= 0} {
	    bell
	    puts "GENE ID DUPLICATION FOUND"
	    puts "$curr_seqs IS DUPLICATED, LINE: $i"
	    update
	    after 2000
	    bell
	    after 1000
	    bell
	    puts "RE-CHECK GENE COORDS FILE"
	    puts "GENE ID MUST BE UNIQ!"
	    .genpix.canvas create text 100 100 -text \
		"GENE ID DUPLICATION FOUND\nCHECK COORDS INPUT FILE\nFOR GENE ID DUPLICATION" \
		-fill "blue" -anchor sw
	    .genpix.canvas create text 100 180 -text "GENE ID: $curr_seqs IS DUPLICATED!" -fill "red" -anchor sw
	}
	set line_test [expr fmod($i, 100)]
	if {$line_test == 0} {
	    puts "$i LINES PROCESSED \[ CANVAS COORDS TEMP FILE \]"
	    update
	}
	incr i
    }
    # TOTAL NUMBER OF GENES ON CANVAS #
    puts "$i GENES ON CANVAS"

    ####################
    # READ MATRIX FILE #
    ####################
    set j 0
    while {[gets $f_in  input] >= 0} {
	set sequenceID1 [lindex [split $input] 0]
	set sequenceID2 [lindex [split $input] 1]
	set matchDegree [lindex [split $input] 2]
	set familyGroup [lindex [split $input] 3]
	set familyColor "$default_familyColor"
	set query1a [info exists curr_coordX($sequenceID1)]
	set query1b [info exists curr_coordY($sequenceID2)]
	set query2a [info exists curr_coordX($sequenceID2)]
	set query2b [info exists curr_coordY($sequenceID1)]
	if {$query1a == 1 && $query1b == 1} {
	    set x1 $curr_coordX($sequenceID1)
	    set y1 $curr_coordY($sequenceID1)
	    set x2 $curr_coordX($sequenceID2)
	    set y2 $curr_coordY($sequenceID2)
	    PlaceSimLine $sequenceID1 $sequenceID2 $matchDegree $familyColor $familyGroup \
		$upSimtyBound $loSimtyBound $x1 $y1 $x2 $y2
	    update
	}
	if {$query2a == 1 && $query2b == 1} {
	    set x1 $curr_coordX($sequenceID2)
	    set y1 $curr_coordY($sequenceID2)
	    set x2 $curr_coordX($sequenceID1)
	    set y2 $curr_coordY($sequenceID1)
	    PlaceSimLine $sequenceID1 $sequenceID2 $matchDegree $familyColor $familyGroup \
		$upSimtyBound $loSimtyBound $x1 $y1 $x2 $y2
	    update
	}
	incr j
	set line_test [expr fmod($j, 100)]
	if {$line_test == 0} {
	    puts "$j LINES PROCESSED \[ MATRIX FILE \]"
	    update
	}
    }
    # TOTAL NUMBER OF LINES IN MATRIX FILE #
    puts "$j PAIRS IN MATRIX LOADED"

    close $f_in
    close $f_search
}

proc PlaceSimLine {sequenceID1 sequenceID2 matchDegree familyColor familyGroup upSimtyBound loSimtyBound x1 y1 x2 y2} {

    global default_familyColor

    global level_of_similarity_1 level_of_similarity_2 level_of_similarity_3
    global level_of_similarity_4 level_of_similarity_5 level_of_similarity_6

    global color_of_similarity_1 color_of_similarity_2 color_of_similarity_3
    global color_of_similarity_4 color_of_similarity_5 color_of_similarity_6

    set destfile "line_coordinates.txt"
    set f_out [open "$destfile"  "a"]

    ######################################################
    if {$familyGroup == ""} {
	set familyColor "$default_familyColor"
    }
    ######################################################
    set matrix_tuner_flag "OFF"
    set is_it_there [winfo exists .fine_matrix_color]
    if {$is_it_there == 1} {
	set matrix_tuner_flag "ON"
    }
    ######################################################
    if {$matrix_tuner_flag == "ON"} {
	if {$matchDegree >= $level_of_similarity_1} {
	    set familyColor "$color_of_similarity_1"
	}
	if {$matchDegree >= $level_of_similarity_2 && $matchDegree < $level_of_similarity_1} {
	    set familyColor "$color_of_similarity_2"
	}
	if {$matchDegree >= $level_of_similarity_3 && $matchDegree < $level_of_similarity_2} {
	    set familyColor "$color_of_similarity_3"
	}
	if {$matchDegree >= $level_of_similarity_4 && $matchDegree < $level_of_similarity_3} {
	    set familyColor "$color_of_similarity_4"
	}
	if {$matchDegree >= $level_of_similarity_5 && $matchDegree < $level_of_similarity_4} {
	    set familyColor "$color_of_similarity_5"
	}
	if {$matchDegree >= $level_of_similarity_6 && $matchDegree < $level_of_similarity_5} {
	    set familyColor "$color_of_similarity_6"
	}
	if {$matchDegree < $level_of_similarity_6} {
	    set familyColor ""
	}
    }
    ######################################################
    if {$matrix_tuner_flag == "OFF"} {
	if {$familyGroup == "black"} {
	    set familyColor "black"
	}
	if {$familyGroup == "blue"} {
	    set familyColor "blue"
	}
	if {$familyGroup == "blue4"} {
	    set familyColor "blue4"
	}
	if {$familyGroup == "brown"} {
	    set familyColor "brown"
	}
	if {$familyGroup == "cyan"} {
	    set familyColor "cyan"
	}
	if {$familyGroup == "gold"} {
	    set familyColor "gold"
	}
	if {$familyGroup == "gray"} {
	    set familyColor "gray"
	}
	if {$familyGroup == "gray25"} {
	    set familyColor "gray25"
	}
	if {$familyGroup == "gray50"} {
	    set familyColor "gray50"
	}
	if {$familyGroup == "gray75"} {
	    set familyColor "gray75"
	}
	if {$familyGroup == "gray90"} {
	    set familyColor "gray90"
	}
	if {$familyGroup == "green"} {
	    set familyColor "green"
	}
	if {$familyGroup == "green4"} {
	    set familyColor "green4"
	}
	if {$familyGroup == "lightblue"} {
	    set familyColor "lightblue"
	}
	if {$familyGroup == "orange"} {
	    set familyColor "orange"
	}
	if {$familyGroup == "pink"} {
	    set familyColor "pink"
	}
	if {$familyGroup == "purple"} {
	    set familyColor "purple"
	}
	if {$familyGroup == "red"} {
	    set familyColor "red"
	}
	if {$familyGroup == "salmon"} {
	    set familyColor "salmon"
	}
	if {$familyGroup == "violet"} {
	    set familyColor "violet"
	}
	if {$familyGroup == "white"} {
	    set familyColor "white"
	}
	if {$familyGroup == "yellow"} {
	    set familyColor "yellow"
	}
	if {$familyGroup == "yellow3"} {
	    set familyColor "yellow3"
	}
    }
    ######################################################
    if {$matchDegree >= $loSimtyBound && $matchDegree <= $upSimtyBound} {	    
	.genpix.canvas create line $x1 $y1 $x2 $y2 -fill $familyColor -tags "identity_tag identity$familyColor"
	puts $f_out "$sequenceID1\t$sequenceID2\t$x1\t$y1\t$x2\t$y2\t$familyColor\t$matchDegree"
	update
    }
    close $f_out
}

proc Family_Color_Error_Report {} {

    destroy .color_error
    set bart_image [image create photo -height 58 -width 46 \
    -file ./Images/bart.gif]
    set color_error_text \
"Sorry, one of gene family colors
from your matrix file is not defined 
in current version of GenomePixelizer. 
Please, re-check your input file."
    toplevel .color_error
    wm title .color_error "Error Report"
    wm protocol .color_error WM_DELETE_WINDOW "destroy .color_error"
    label .color_error.image -image $bart_image
    label .color_error.text -text $color_error_text -justify center
    button .color_error.dismiss -text "Dismiss" -command {destroy .color_error}
    pack .color_error.image -padx 7 -pady 7
    pack .color_error.text -padx 2 -pady 2
    pack .color_error.dismiss -padx 2 -pady 2

}

proc showName {c layer} {

    global annotation_array
    global annotation_status

    set is_it_here [winfo exists $layer]
    if {$is_it_here == "0"} {
	Show_Gene_ID
    }

    $layer delete 0 end
    $layer insert end $c

    if {$annotation_status == "TRUE"} {
	set is_it_there [winfo exists .annot_text.info]
	if {$is_it_there == "0"} {
	    Annot_Window
	}
	set query1 [info exists annotation_array($c)]
	if { $query1 == 1 } {
	    puts "Annotation: $c -=- $annotation_array($c)"
	    .annot_text.info delete 1.0 end
	    .annot_text.info insert end "=======\n$c -=- $annotation_array($c)\n======="
	} else {
	    puts "node_A: $c -=- no data"
	    .annot_text.info delete 1.0 end
	    .annot_text.info insert end "=======\n$c -=- No data\n======="
	}
    }
}

# given a gene id, flash that on canvas

proc highLightGene { w tn } {

    global abc_tag

    set old_colour [lindex [$w itemconfig $abc_tag$tn -fill] 4]
    $w itemconfigure $abc_tag$tn -fill yellow
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill orange
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill red
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill purple
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill blue
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill black
    update
    after 150 
    $w itemconfigure $abc_tag$tn -fill yellow
    update
    after 150
    $w itemconfigure $abc_tag$tn -fill $old_colour
    update
    after 150
    bell
}

############ Scrolled Canvas ################
#            ---------------                #
#         Create Scrolled Canvas            #
#                                           #
#############################################
proc Scrolled_Canvas { genpix args } {
    toplevel $genpix
    wm title $genpix "GenomePixelizer Canvas"
    wm protocol $genpix WM_DELETE_WINDOW "destroy $genpix .idlabel"

    eval {canvas $genpix.canvas -xscrollcommand [list $genpix.xscroll set] \
	  -yscrollcommand [list $genpix.yscroll set] \
	  -highlightthickness 0 -borderwidth 0} $args
    
    scrollbar $genpix.xscroll -orient horizontal \
	      -command [list $genpix.canvas xview]
    scrollbar $genpix.yscroll -orient vertical \
              -command [list $genpix.canvas yview]

    grid $genpix.canvas $genpix.yscroll -sticky news
    grid $genpix.xscroll -sticky ew
    grid rowconfigure $genpix 0 -weight 1
    grid columnconfigure $genpix 0 -weight 1
    return $genpix.canvas
}

############ HTML ScreenShot ################
#            ---------------                #
#        Procedure HTML ScreenShot          #
#       defines the area on canvas          #
#          for proper screenshot            #
#############################################

proc Html_ScreenShot { horizontal_size vertical_size } {
    .genpix.canvas create line 0 0 [expr $horizontal_size -1] 0 -fill gray 
    .genpix.canvas create line 0 0 0 [expr $vertical_size -1] -fill gray
    .genpix.canvas create line   [expr $horizontal_size -1] 0 [expr $horizontal_size -1]\
	                    [expr $vertical_size -1] -fill gray
    .genpix.canvas create line 0 [expr $vertical_size -1] [expr $horizontal_size -1]\
	                    [expr $vertical_size -1] -fill gray
}

proc Canvas_Html_Size { horizontal_size vertical_size genes_coord_file} {

    set html_out [open $genes_coord_file "a"]
    puts $html_out \n
    puts $html_out "\<\!\-\- screenshot horizontal size\: $horizontal_size \
	            screenshot vertical size\: $vertical_size \-\-\>"
    close $html_out
}

##################################################
#      GenomePixelizer advanced Help system      #
##################################################
proc Show_Documentation {} {
    destroy .gen_pix_manual
    set gen_pix_doc [open "./Tutorial/GenoPix_Help.txt" r]
    set text_manual [read $gen_pix_doc]
    close $gen_pix_doc
    toplevel .gen_pix_manual 
    wm title .gen_pix_manual "GenomePixelizer Help"
    wm protocol .gen_pix_manual WM_DELETE_WINDOW "destroy .gen_pix_manual"
    label .gen_pix_manual.text_manual -text $text_manual -justify center
    button .gen_pix_manual.dismiss -text "Dismiss" -command "destroy .gen_pix_manual"
    grid .gen_pix_manual.text_manual -padx 2 -pady 2
    grid .gen_pix_manual.dismiss -padx 2 -pady 2
}

##################################################
#           GenomePixelizer Tutorial             #
##################################################
proc GenPix_Tutorial_00 {} {
    destroy .gen_pix_tutorial
    destroy .gen_pix_wisdom
    set gen_pix_banner [image create photo -height 58 -width 269 \
    -file ./Images/GenoPix_Banner.gif]
    set gen_pix_wisdom [open "./Tutorial/Tutorial_00.txt" r]
    set text_wisdom [read $gen_pix_wisdom]
    close $gen_pix_wisdom
    toplevel .gen_pix_wisdom 
    wm title .gen_pix_wisdom "GenomePixelizer Tutorial Wisdom"
    wm protocol .gen_pix_wisdom WM_DELETE_WINDOW "destroy .gen_pix_wisdom"
    label .gen_pix_wisdom.image -image $gen_pix_banner
    label .gen_pix_wisdom.text_wisdom -text $text_wisdom -justify center
    button .gen_pix_wisdom.next -text "Next" -command {GenPix_Tutorial_01}
    pack .gen_pix_wisdom.image -padx 7 -pady 7
    pack .gen_pix_wisdom.text_wisdom -padx 2 -pady 2
    pack .gen_pix_wisdom.next -padx 2 -pady 2

}
##################################################
proc GenPix_Tutorial_01 {} {
    destroy .gen_pix_wisdom
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_01.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 01"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_02}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.features -text "GenomePixelizer Features" -command {Show_Features}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.features -padx 2 -pady 2
}
proc Show_Features {} {
    destroy .gen_pix_features
    set gen_pix_features [open "./Tutorial/GenPix_Features.txt" r]
    set text_features [read $gen_pix_features]
    close $gen_pix_features
    toplevel .gen_pix_features
    wm title .gen_pix_features "GenomePixelizer Features"
    wm protocol .gen_pix_features WM_DELETE_WINDOW "destroy .gen_pix_features"
    label .gen_pix_features.text_features -text $text_features -justify left
    button .gen_pix_features.dismiss -text "Dismiss" -command "destroy .gen_pix_features"
    pack .gen_pix_features.text_features -padx 2 -pady 2
    pack .gen_pix_features.dismiss -padx 2 -pady 2
}
##################################################
proc Show_Next_Tutorial_02 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_02.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 02"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_03}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {GenPix_Tutorial_01}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
##################################################
proc Show_Next_Tutorial_03 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_03.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 03"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_04}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_02}
    button .gen_pix_tutorial.input_file -text "RunSetup File" -command {Show_RunSetupFile}
    button .gen_pix_tutorial.coord_file -text "Gene Coordinates File" -command {Show_CoordFile}
    button .gen_pix_tutorial.matrix_file -text "Matrix File" -command {Show_MatrixFile}
    pack .gen_pix_tutorial.input_file -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_file -padx 2 -pady 2
    pack .gen_pix_tutorial.matrix_file -padx 2 -pady 2
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
##################################################
proc Show_RunSetupFile {} {
    destroy .gen_pix_runsetup
    set gen_pix_runsetup [open "./Tutorial/GenPix_RunSetup_Tutorial.txt" r]
    set text_runsetup [read $gen_pix_runsetup]
    close $gen_pix_runsetup
    toplevel .gen_pix_runsetup 
    wm title .gen_pix_runsetup "GenomePixelizer RunSetup File"
    wm protocol .gen_pix_runsetup WM_DELETE_WINDOW "destroy .gen_pix_runsetup"
    label .gen_pix_runsetup.text_runsetup -text $text_runsetup -font courier -justify left
    button .gen_pix_runsetup.dismiss -text "Dismiss" -command "destroy .gen_pix_runsetup"
    pack .gen_pix_runsetup.text_runsetup  -padx 2 -pady 2
    pack .gen_pix_runsetup.dismiss -padx 2 -pady 2
}
##################################################
proc Show_CoordFile {} {
    destroy .gen_pix_coord
    set gen_pix_coord [open "./Tutorial/GenPix_Tutorial_Input" r]
    set text_coord [read $gen_pix_coord]
    close $gen_pix_coord
    toplevel .gen_pix_coord
    wm title .gen_pix_coord "GenomePixelizer Input File"
    wm protocol .gen_pix_coord WM_DELETE_WINDOW "destroy .gen_pix_coord"
    label .gen_pix_coord.text_coord -text $text_coord -font courier -justify left
    button .gen_pix_coord.dismiss -text "Dismiss" -command "destroy .gen_pix_coord"
    pack .gen_pix_coord.text_coord -padx 2 -pady 2
    pack .gen_pix_coord.dismiss -padx 2 -pady 2
}

proc Show_CoordFile_Ext {} {
    destroy .gen_pix_coord_ext
    set gen_pix_coord_ext [open "./Tutorial/GenPix_Tutorial_Input_Ext_A" r]
    set text_coord_ext [read $gen_pix_coord_ext]
    close $gen_pix_coord_ext
    toplevel .gen_pix_coord_ext
    wm title .gen_pix_coord_ext "GenomePixelizer Input File Extended"
    wm protocol .gen_pix_coord_ext WM_DELETE_WINDOW "destroy .gen_pix_coord_ext"
    label .gen_pix_coord_ext.text_coord_ext -text $text_coord_ext -font courier -justify left
    button .gen_pix_coord_ext.dismiss -text "Dismiss" -command "destroy .gen_pix_coord_ext"
    pack .gen_pix_coord_ext.text_coord_ext -padx 2 -pady 2
    pack .gen_pix_coord_ext.dismiss -padx 2 -pady 2
}

proc Show_CoordFile_WC {} {
    destroy .gen_pix_coord_wc
    set gen_pix_coord_wc [open "./Tutorial/GenPix_Tutorial_Input.wc" r]
    set text_coord_wc [read $gen_pix_coord_wc]
    close $gen_pix_coord_wc
    toplevel .gen_pix_coord_wc
    wm title .gen_pix_coord_wc "GenomePixelizer -WC Input File"
    wm protocol .gen_pix_coord_wc WM_DELETE_WINDOW "destroy .gen_pix_coord_wc"
    label .gen_pix_coord_wc.text_coord_wc -text $text_coord_wc -font courier -justify left
    button .gen_pix_coord_wc.dismiss -text "Dismiss" -command "destroy .gen_pix_coord_wc"
    pack .gen_pix_coord_wc.text_coord_wc -padx 2 -pady 2
    pack .gen_pix_coord_wc.dismiss -padx 2 -pady 2
}
##################################################
proc Scrolled_Text { fly args } {
    toplevel $fly
    eval {text $fly.text -wrap none \
           -xscrollcommand [list $fly.xscroll set] \
           -yscrollcommand [list $fly.yscroll set]} $args
    scrollbar $fly.xscroll -orient horizontal \
              -command [list $fly.text xview]
    scrollbar $fly.yscroll -orient vertical \
              -command [list $fly.text yview]
    grid $fly.text $fly.yscroll -sticky news
    grid $fly.xscroll -sticky news
    grid rowconfigure $fly 0 -weight 1
    grid columnconfigure $fly 0 -weight 1
    button $fly.dismiss -text "Dismiss" -command "destroy .fly"
    grid $fly.dismiss -padx 2 -pady 2

    return $fly.text
}
##################################################
proc Show_MatrixFile {} {
    destroy .fly
    set t [Scrolled_Text .fly -width 60 -height 40]
    set in [open "./Tutorial/GenPix_Tutorial_Matrix" r]
    $t insert end [read $in]
    close $in
    wm title .fly "GenomePixelizer Matrix File"
    wm protocol .fly WM_DELETE_WINDOW "destroy .fly"
}
##################################################
proc Show_Next_Tutorial_04 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_04.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 04"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_05}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_03}
    button .gen_pix_tutorial.color_map -text \
	    "GenomePixelizer Color Map" -command {Show_Color_Map}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.color_map -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}

proc Show_Color_Map {} {
    destroy .gen_pix_colormap
    set gen_pix_colormap [open "./Tutorial/GenPix_ColorMap.txt" r]
    set text_colormap [read $gen_pix_colormap]
    close $gen_pix_colormap
    toplevel .gen_pix_colormap
    wm title .gen_pix_colormap "GenomePixelizer Color Map"
    wm protocol .gen_pix_colormap WM_DELETE_WINDOW "destroy .gen_pix_colormap"
    label .gen_pix_colormap.text_colormap -text $text_colormap -justify left
    button .gen_pix_colormap.dismiss -text "Dismiss" -command "destroy .gen_pix_colormap"
    pack .gen_pix_colormap.text_colormap -padx 2 -pady 2
    pack .gen_pix_colormap.dismiss -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_05 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_05.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 05"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.html_example \
    -text "html_image_map_coord.txt File" -command {Show_HTML_File}
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_06}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_04}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.html_example -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}

proc Show_HTML_File {} {
    destroy .gen_pix_html
    set gen_pix_html [open "./Tutorial/Tutorial_HTML_coord.txt" r]
    set text_html [read $gen_pix_html]
    close $gen_pix_html
    toplevel .gen_pix_html
    wm title .gen_pix_html "GenomePixelizer HTML File"
    wm protocol .gen_pix_html WM_DELETE_WINDOW "destroy .gen_pix_html"
    label .gen_pix_html.text_html -text $text_html -justify left
    button .gen_pix_html.dismiss -text "Dismiss" -command "destroy .gen_pix_html"
    pack .gen_pix_html.text_html -padx 2 -pady 2
    pack .gen_pix_html.dismiss -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_06 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_06.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 06"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.coord_file -text "Gene Coordinates File" -command {Show_CoordFile}
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_07}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_05}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_file -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_07 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_07.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 07"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.coord_file -text "Gene Coordinates File" -command {Show_CoordFile}
    button .gen_pix_tutorial.coord_wc_file \
    -text "Gene Coordinates File -WC" -command {Show_CoordFile_WC}
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_08}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_06}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_file -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_wc_file -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_08 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_08.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 08"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_09}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_07}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_09 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_09.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 09"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_10}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_08}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_10 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_10.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 10"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_Next_Tutorial_11}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_09}
    button .gen_pix_tutorial.coord_file -text "Gene Coordinates File" \
	    -command {Show_CoordFile}
    button .gen_pix_tutorial.coord_file_ext -text "Gene Coordinates File Extended" \
	    -command {Show_CoordFile_Ext}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_file -padx 2 -pady 2
    pack .gen_pix_tutorial.coord_file_ext -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_Next_Tutorial_11 {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_11.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial 11"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.next -text "Next" -command {Show_End_Tutorial}
    button .gen_pix_tutorial.dismiss -text "Dismiss" -command "destroy .gen_pix_tutorial"
    button .gen_pix_tutorial.previous -text "Back" -command {Show_Next_Tutorial_10}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.next -side right -padx 2 -pady 2
    pack .gen_pix_tutorial.dismiss -side left -padx 2 -pady 2
    pack .gen_pix_tutorial.previous -padx 2 -pady 2
}
#######################################################
proc Show_End_Tutorial {} {
    destroy .gen_pix_tutorial
    set gen_pix_tutorial [open "./Tutorial/Tutorial_END.txt" r]
    set text_tutorial [read $gen_pix_tutorial]
    set gen_pix_tao [image create photo -height 49 -width 43 -file ./Images/z-taocar.gif]
    close $gen_pix_tutorial
    toplevel .gen_pix_tutorial 
    wm title .gen_pix_tutorial "GenomePixelizer Tutorial Tao"
    wm protocol .gen_pix_tutorial WM_DELETE_WINDOW "destroy .gen_pix_tutorial"
    label .gen_pix_tutorial.text_tutorial -text $text_tutorial -justify left
    button .gen_pix_tutorial.tao -image $gen_pix_tao -bg lightblue \
	    -command {GenPix_Tutorial_00}
    pack .gen_pix_tutorial.text_tutorial -padx 2 -pady 2
    pack .gen_pix_tutorial.tao -padx 3 -pady 3 
}
#######################################################
proc Show_Feedback {} {

set text_feedback "You are very welcome to send us
your suggestions and bug reports to improve 
the features of current release.
Alex Kozik email: akozik@atgc.org
Lena Kochetkova email: 
elenakochetkova@netscape.net
Richard Michelmore email:
michelmore@vegmail.ucdavis.edu"

    destroy .feedback_report
    toplevel .feedback_report 
    wm title .feedback_report "Feedback"
    wm protocol .feedback_report WM_DELETE_WINDOW "destroy .feedback_report"

    label .feedback_report.text -text $text_feedback -justify center
    button .feedback_report.ok -text "Dismiss" -command "destroy .feedback_report"
    grid .feedback_report.text -padx 2 -pady 2
    grid .feedback_report.ok -padx 2 -pady 2

}
#######################################################
proc About_Supplement {} {

set text_supplement "Supplemental packages are not required 
to run GenomePixelizer, however, they are considered 
as very helpful tools to:
1. Automatically create sub-project to view the 
selected locus in full details using \"Locus Zoomer\".
2. Validate matrix file using \"Matrix Validator\".
3. Edit images on canvas using \"Canvas Editor\".
4. Visualize the sequence alignment by \"Alignment Viewer\".
"
    destroy .supplement_report
    toplevel .supplement_report 
    wm title .supplement_report "Supplement"
    wm protocol .supplement_report WM_DELETE_WINDOW "destroy .supplement_report"

    label .supplement_report.text -text $text_supplement -justify center
    button .supplement_report.ok -text "Dismiss" -command "destroy .supplement_report"
    grid .supplement_report.text -padx 2 -pady 2
    grid .supplement_report.ok -padx 2 -pady 2
}

################################################
#            ==================                #
#       LIST OF ALIGNMENT PROCEDURES           #
#            ==================                #
################################################

########################################
#    SCROLLED ALIGNMENT PROCEDURE      #
#    ----------------------------      #
########################################

proc How_To_Alignment {} {

set text_how_to "
Place your alignment in 
ClustalW format into \"Alignments\" 
directory, type in entry window 
name of the alignment file and 
click \"View Alignment\"\.
"

    destroy .how_to_alignment
    toplevel .how_to_alignment 
    wm title .how_to_alignment "How To"
    wm protocol .how_to_alignment WM_DELETE_WINDOW "destroy .how_to_alignment"

    label .how_to_alignment.text -text $text_how_to -justify center
    button .how_to_alignment.ok -text "Dismiss" -command "destroy .how_to_alignment"
    grid .how_to_alignment.text -padx 2 -pady 2
    grid .how_to_alignment.ok -padx 2 -pady 2
}

proc Scrolled_Alignment { c args } {
        toplevel $c
        eval {canvas $c.alignment \
                -xscrollcommand [list $c.xscroll set] \
                -yscrollcommand [list $c.yscroll set] \
                -highlightthickness 0 \
                -borderwidth 0} $args
        scrollbar $c.xscroll -orient horizontal \
                -command [list $c.alignment xview]
        scrollbar $c.yscroll -orient vertical \
                -command [list $c.alignment yview]
        grid $c.alignment $c.yscroll -sticky news
        grid $c.xscroll -sticky ew
        grid rowconfigure $c 0 -weight 1
        grid columnconfigure $c 0 -weight 1
        return $c.alignment
}

#####################################
#     REFORMAT CLUSTALW FILE        #
#     ----------------------        #

proc Reformat_ClustalW {} {

    global input_the_alignment

    set alignment_file "./Alignments/$input_the_alignment"
    set alignment_data_A [open "$alignment_file" "r"]  
    set alignment_to_open "./Alignments/temp_ClustalW_Reformated"
    set reformated_alignment [open $alignment_to_open "w"]
    set gene_counter 0

    while {[gets $alignment_data_A current_line] >= 0 } {
	set gene_id_A "[lindex $current_line 0]"
	
	if {$gene_id_A == "CLUSTAL" || $gene_id_A == "\." ||\
	    $gene_id_A == "\:"      || $gene_id_A == "\*" ||\
	    $gene_id_A == ""} {

	        unset gene_id_A
		set gene_id_A ""
		continue
        }
	if {$gene_counter == 0 } {
	    set first_gene_id $gene_id_A
	    puts $first_gene_id
	}
	incr gene_counter
	
	if {"$gene_id_A" == "$first_gene_id" && $gene_counter > 1} {
	    break
	}
	puts $gene_counter
	puts -nonewline $reformated_alignment $gene_id_A\t
	set alignment_data_B [open $alignment_file "r"]
	
	while {[gets $alignment_data_B current_line] >= 0 } {
	    set gene_id_B "[lindex $current_line 0]"
	    set gene_sequence_B "[lindex $current_line 1]"
	    
	    if {"$gene_id_A" == "$gene_id_B"} {
		puts -nonewline $reformated_alignment $gene_sequence_B
	    }
	}
        puts -nonewline $reformated_alignment \n
    }
    close $alignment_data_A
    close $reformated_alignment
    close $alignment_data_B
}

#####################################
#      CANVAS SIZE ESTIMATION       #
#      ----------------------       #

proc Get_Canvas_Size {} {
    global line_counter
    global alignment_length
    set alignment_file "./Alignments/temp_ClustalW_Reformated"
    set alignment_data [open $alignment_file r]
    set line_counter 0

    while {[gets $alignment_data current_line] >= 0 } {
	incr line_counter
	puts $line_counter
	if {$line_counter == 1} {
	    set alignment_string "[lindex $current_line 1]"
	    set alignment_length [string length "$alignment_string"]
	    puts $alignment_length
	}
    }
}

#####################################
#   DRAW THE ALIGNMENT PROCEDURE    #
#   ----------------------------    #

proc Draw_Alignment {} {

    Be_Patient
    update

########################
    destroy .mouse_alignment
    destroy .c

    Reformat_ClustalW
    Get_Canvas_Size

    global alignment_text_color
    global alignment_background
    global max_x max_y
    global input_the_alignment
    global line_counter
    global alignment_length
    global color_A color_B color_C color_D color_E color_F color_G color_H \
	   color_I color_J color_K color_L color_M color_N color_O color_P \
	   color_Q color_R color_S color_T color_U color_V color_W color_X \
	   color_Y color_Z
    set max_x [expr $alignment_length*10 + 150]
    set max_y [expr $line_counter*10 + 70]
    Scrolled_Alignment .c -width 600 -height 400         \
	                -scrollregion "0 0 $max_x $max_y"\
			-bg $alignment_background
    .c.alignment create rect 0 0 $max_x $max_y \
	    -fill $alignment_background -outline $alignment_background

    ########################
    wm title .c "Alignment Canvas"
    wm protocol .c WM_DELETE_WINDOW "destroy .c .mouse_alignment .inconvenience"

    set alignment_file "./Alignments/temp_ClustalW_Reformated"
    set alignment_data [open $alignment_file r]

    .c.alignment create text 20 20 -text "$input_the_alignment"\
	         -anchor sw -font courier -fill $alignment_text_color

    set banner_level 20
    set gene_level [expr $banner_level + 30]
    set k 0

    while {[gets $alignment_data current_line] >= 0 } {
	set gene_id($k) "[lindex $current_line 0]"
	set gene_sequence "[lindex $current_line 1]"	
	set amino_acid [split $gene_sequence {}]
	set am_ac_position 100
	set am_ac_color "white"
     
	if {$gene_id($k) == "CLUSTAL" || $gene_id($k) == "\." ||\
	    $gene_id($k) == "\:"      || $gene_id($k) == "\*" ||\
	    $gene_id($k) == ""} {
	    
	    unset gene_id($k)
	    set gene_id($k) ""
	    unset amino_acid
	    set amino_acid ""
	    continue
	}

	set l 0
	foreach am_ac $amino_acid {
	    if {$am_ac == "-"} {
		set am_ac_color gray
	    }
	    if {$am_ac == "K"} {
		set am_ac_color $color_K
	    }
	    if {$am_ac == "R"} {
		set am_ac_color $color_R
	    }
	    if {$am_ac == "H"} {
		set am_ac_color $color_H
	    }
	    if {$am_ac == "S"} {
		set am_ac_color $color_S
	    }
	    if {$am_ac == "T"} {
		set am_ac_color $color_T
	    }
	    if {$am_ac == "N"} {
		set am_ac_color $color_N
	    }
	    if {$am_ac == "Q"} {
		set am_ac_color $color_Q
	    }
	    if {$am_ac == "D"} {
		set am_ac_color $color_D
	    }
	    if {$am_ac == "E"} {
		set am_ac_color $color_E
	    }
	    if {$am_ac == "A"} {
		set am_ac_color $color_A
	    }
	    if {$am_ac == "V"} {
		set am_ac_color $color_V
	    }
	    if {$am_ac == "I"} {
		set am_ac_color $color_I
	    }
	    if {$am_ac == "L"} {
		set am_ac_color $color_L
	    }
	    if {$am_ac == "M"} {
		set am_ac_color $color_M
	    }
	    if {$am_ac == "F"} {
		set am_ac_color $color_F
	    }
	    if {$am_ac == "Y"} {
		set am_ac_color $color_Y
	    }
	    if {$am_ac == "W"} {
		set am_ac_color $color_W
	    }
	    if {$am_ac == "C"} {
		set am_ac_color $color_C
	    }
	    if {$am_ac == "G"} {
		set am_ac_color $color_G
	    }
	    if {$am_ac == "P"} {
		set am_ac_color $color_P
	    }
	    if {$am_ac == "B"} {
		set am_ac_color $color_B
	    }
	    if {$am_ac == "J"} {
		set am_ac_color $color_J
	    }
	    if {$am_ac == "O"} {
		set am_ac_color $color_O
	    }
	    if {$am_ac == "U"} {
		set am_ac_color $color_U
	    }
	    if {$am_ac == "X"} {
		set am_ac_color $color_X
	    }
	    if {$am_ac == "Z"} {
		set am_ac_color $color_Z
	    }

	    .c.alignment create text 6 $gene_level -text "$gene_id($k)" \
		         -anchor sw -font courier -fill $alignment_text_color -tag id($k)
	    .c.alignment bind id($k) <Button-1> "showName $gene_id($k) .mouse_alignment.geneid"

	    .c.alignment create text $am_ac_position $gene_level -text "$am_ac"\
		         -anchor sw -font courier -fill $am_ac_color -tag belonging($k)
	    .c.alignment bind  belonging($k) <Button-1> "showName \
		    $gene_id($k) .mouse_alignment.geneid"  

	    incr am_ac_position 10
	    incr l
	}
	update
	incr gene_level 10
	incr k
    }

    #################################################
    #            ALIGNMENT RULER                    #
    set alignment_label 10
    global alignment_text_color
    while  {$alignment_label <= $alignment_length } {
	set alignment_label_position [expr $alignment_label*10 + 100]
	set alignment_label_position_true [expr $alignment_label_position - 10]
        .c.alignment create text $alignment_label_position_true 38 \
	    -text "$alignment_label" -anchor sw -font courier -fill $alignment_text_color
        incr alignment_label 10
    }
    #################################################
    End_Be_Patient
    bell
    close $alignment_data
    Mouse_Over_Alignment
}

proc Mouse_Over_Alignment {} {

    destroy .mouse_alignment
    toplevel .mouse_alignment
    wm transient .mouse_alignment .c
    wm title .mouse_alignment "Gene ID"
    wm protocol .mouse_alignment WM_DELETE_WINDOW "destroy .mouse_alignment"
    label .mouse_alignment.label -text "Gene ID:" -justify right -bg gray -width 10
    entry .mouse_alignment.geneid -relief sunken -textvariable Name_of_Gene -bg lightblue
    grid .mouse_alignment.label .mouse_alignment.geneid -padx 3 -pady 3
}

proc Destroy_Alignment {} {
    destroy .mouse_alignment
    destroy .c
}

proc View_the_Alignment {} {

    destroy .alignment_viewer
    toplevel .alignment_viewer
    wm title .alignment_viewer "Alignment Viewer"
    wm protocol .alignment_viewer WM_DELETE_WINDOW \
	    "destroy .alignment_viewer .inconvenience .aa_credits"

    global color_K
    set color_K "red"
    button .alignment_viewer.color_label_K -text "Lysine lys (K)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_K}
    entry .alignment_viewer.input_color_K -relief sunken -textvariable color_K \
	    -bg lightblue -width 12

    global color_R
    set color_R "red"
    button .alignment_viewer.color_label_R -text "Arginine arg (R)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_R}
    entry .alignment_viewer.input_color_R -relief sunken -textvariable color_R \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_K .alignment_viewer.input_color_K \
	 .alignment_viewer.color_label_R .alignment_viewer.input_color_R 

    global color_H
    set color_H "red"
    button .alignment_viewer.color_label_H -text "Histidine his (H)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_H}
    entry .alignment_viewer.input_color_H -relief sunken -textvariable color_H \
	    -bg lightblue -width 12

    global color_S
    set color_S "orange"
    button .alignment_viewer.color_label_S -text "Serine ser (S)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_S}
    entry .alignment_viewer.input_color_S -relief sunken -textvariable color_S \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_H .alignment_viewer.input_color_H \
	 .alignment_viewer.color_label_S .alignment_viewer.input_color_S 

    global color_T
    set color_T "orange"
    button .alignment_viewer.color_label_T -text "Threonine thr (T)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_T}
    entry .alignment_viewer.input_color_T -relief sunken -textvariable color_T \
	    -bg lightblue -width 12

    global color_N
    set color_N "yellow"
    button .alignment_viewer.color_label_N -text "Asparagine asn (N)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_N}
    entry .alignment_viewer.input_color_N -relief sunken -textvariable color_N \
	    -bg lightblue -width 12
    
    grid .alignment_viewer.color_label_T .alignment_viewer.input_color_T \
	 .alignment_viewer.color_label_N .alignment_viewer.input_color_N 

    global color_Q
    set color_Q "yellow"
    button .alignment_viewer.color_label_Q -text "Glutamine gln (Q)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_Q}
    entry .alignment_viewer.input_color_Q -relief sunken -textvariable color_Q \
	    -bg lightblue -width 12

    global color_D
    set color_D "yellow"
    button .alignment_viewer.color_label_D -text "Aspartic ac. asp (D)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_D}
    entry .alignment_viewer.input_color_D -relief sunken -textvariable color_D \
	    -bg lightblue -width 12
    
    grid .alignment_viewer.color_label_Q .alignment_viewer.input_color_Q \
	 .alignment_viewer.color_label_D .alignment_viewer.input_color_D 

    global color_E
    set color_E "yellow"
    button .alignment_viewer.color_label_E -text "Glutamic ac. glu (E)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_E}
    entry .alignment_viewer.input_color_E -relief sunken -textvariable color_E \
	    -bg lightblue -width 12

    global color_A
    set color_A "yellow"
    button .alignment_viewer.color_label_A -text "Alanine ala (A)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_A}
    entry .alignment_viewer.input_color_A -relief sunken -textvariable color_A \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_E .alignment_viewer.input_color_E \
	 .alignment_viewer.color_label_A .alignment_viewer.input_color_A 

    global color_V
    set color_V "green"
    button .alignment_viewer.color_label_V -text "Valine val (V)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_V}
    entry .alignment_viewer.input_color_V -relief sunken -textvariable color_V \
	    -bg lightblue -width 12

    global color_I
    set color_I "green"
    button .alignment_viewer.color_label_I -text "Isoleucine ile (I)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_I}
    entry .alignment_viewer.input_color_I -relief sunken -textvariable color_I \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_V .alignment_viewer.input_color_V \
	 .alignment_viewer.color_label_I .alignment_viewer.input_color_I 

    global color_L
    set color_L "green"
    button .alignment_viewer.color_label_L -text "Leucine leu (L)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_L}
    entry .alignment_viewer.input_color_L -relief sunken -textvariable color_L \
	    -bg lightblue -width 12

    global color_M
    set color_M "green"
    button .alignment_viewer.color_label_M -text "Methionine met (M)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_M}
    entry .alignment_viewer.input_color_M -relief sunken -textvariable color_M -bg lightblue -width 12

    grid .alignment_viewer.color_label_L .alignment_viewer.input_color_L \
         .alignment_viewer.color_label_M .alignment_viewer.input_color_M 

    global color_F
    set color_F "cyan"
    button .alignment_viewer.color_label_F -text "Phenylalanine phe (F)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_F}
    entry .alignment_viewer.input_color_F -relief sunken -textvariable color_F \
	    -bg lightblue -width 12

    global color_Y
    set color_Y "cyan"
    button .alignment_viewer.color_label_Y -text "Tyrosine tyr (Y)" \
	    -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_Y}
    entry .alignment_viewer.input_color_Y -relief sunken -textvariable color_Y \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_F .alignment_viewer.input_color_F \
	 .alignment_viewer.color_label_Y .alignment_viewer.input_color_Y 

    global color_W
    set color_W "cyan"
    button .alignment_viewer.color_label_W -text "Tryptophan trp (W)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_W}
    entry .alignment_viewer.input_color_W -relief sunken -textvariable color_W \
	    -bg lightblue -width 12

    global color_C
    set color_C "yellow"
    button .alignment_viewer.color_label_C -text "Cysteine cys (C)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_C}
    entry .alignment_viewer.input_color_C -relief sunken -textvariable color_C \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_W .alignment_viewer.input_color_W \
	 .alignment_viewer.color_label_C .alignment_viewer.input_color_C 

    global color_G
    set color_G "orange"
    button .alignment_viewer.color_label_G -text "Glycine gly (G)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_G}
    entry .alignment_viewer.input_color_G -relief sunken -textvariable color_G \
	    -bg lightblue -width 12

    global color_P
    set color_P "orange"
    button .alignment_viewer.color_label_P -text "Proline pro (P)" \
	   -justify right -bg yellow3 -width 16 -height 1 -command {Show_AA_P}
    entry .alignment_viewer.input_color_P -relief sunken -textvariable color_P \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_G .alignment_viewer.input_color_G \
         .alignment_viewer.color_label_P .alignment_viewer.input_color_P 

    ################## nonsense ###########################################

    global color_B
    set color_B "black"
    button .alignment_viewer.color_label_B -text "B" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_B -relief sunken -textvariable color_B \
	    -bg lightblue -width 12

    global color_J
    set color_J "black"
    button .alignment_viewer.color_label_J -text "J" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_J -relief sunken -textvariable color_J \
	    -bg lightblue -width 12

    global color_O
    set color_O "black"
    button .alignment_viewer.color_label_O -text "O" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_O -relief sunken -textvariable color_O \
	    -bg lightblue -width 12

    global color_U
    set color_U "black"
    button .alignment_viewer.color_label_U -text "U" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_U -relief sunken -textvariable color_U \
	    -bg lightblue -width 12

    global color_X
    set color_X "black"
    button .alignment_viewer.color_label_X -text "X" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_X -relief sunken -textvariable color_X \
	    -bg lightblue -width 12

    global color_Z
    set color_Z "black"
    button .alignment_viewer.color_label_Z -text "Z" -justify right -bg gray -width 4
    entry .alignment_viewer.input_color_Z -relief sunken -textvariable color_Z \
	    -bg lightblue -width 12

    grid .alignment_viewer.color_label_B .alignment_viewer.input_color_B \
	 .alignment_viewer.color_label_J .alignment_viewer.input_color_J \
	 -padx 2 -pady 1 -sticky {}
   
    grid .alignment_viewer.color_label_O .alignment_viewer.input_color_O \
	 .alignment_viewer.color_label_U .alignment_viewer.input_color_U \
	 -padx 2 -pady 1 -sticky {}

    grid .alignment_viewer.color_label_X .alignment_viewer.input_color_X \
	 .alignment_viewer.color_label_Z .alignment_viewer.input_color_Z \
	 -padx 2 -pady 1 -sticky {}

    ###############################################################################

    set text_view_alignment "View\nAlignment"

    button .alignment_viewer.viewit -text "$text_view_alignment" \
	   -bg orange -width 8 -height 2 -command {Draw_Alignment}

    global input_the_alignment
    global alignment_dir
    global ps_alignment_to_save
    global max_x max_y

    set input_the_alignment "GenPix_Tutorial_Seqs.aln"
    set alignment_dir "./Alignments/"

    label .alignment_viewer.nothing -text ""

    entry .alignment_viewer.alignment -relief sunken -textvariable \
	  input_the_alignment -bg white -width 18

    #    set text_destroy "Destroy\nAlignment"
    #    button .alignment_viewer.destroy -text "$text_destroy" -width 8 -height 2 \
    #	   -bg orange -command {Destroy_Alignment}

    button .alignment_viewer.how_to -text "How To" -bg orange -command {How_To_Alignment}
    button .alignment_viewer.warning -text "Warning" -bg violet -command {Show_Warning}
    button .alignment_viewer.aa_credits -text "AA Credits" -bg gray -command {Show_AA_Credits}
    button .alignment_viewer.exit -text "Exit" -bg gray \
	-command {destroy .alignment_viewer .aa_credits .inconvenience}

    grid .alignment_viewer.how_to .alignment_viewer.viewit \
	.alignment_viewer.alignment .alignment_viewer.warning -pady 3

    #####################################
    set ps_alignment_to_save "genopix_alignment.ps"

    button .alignment_viewer.save_ps -text "Generate\nPostScript" -bg brown -fg gold  -height 2 \
	-width 8 -command {.c.alignment postscript -height $max_y -width $max_x \
			       -x -1 -y 0 -file $ps_alignment_to_save} 

    entry .alignment_viewer.ps_file -relief sunken \
	-textvariable ps_alignment_to_save -bg lightblue -width 18
    #####################################

    global alignment_background \
	    alignment_text_color

    set alignment_background "black"
    set alignment_text_color "white"

    label .alignment_viewer.label_background -text "Background:" \
	-width 14 -bg gray

    entry .alignment_viewer.algnmnt_bkrnd -relief sunken \
	-textvariable alignment_background -bg lightblue -width 12

    label .alignment_viewer.label_text_color -text "Text Color:" \
	-width 14 -bg gray

    entry .alignment_viewer.entry_text_color -relief sunken \
	-textvariable alignment_text_color -bg lightblue -width 12

    #####################################
    grid .alignment_viewer.label_background .alignment_viewer.algnmnt_bkrnd \
	.alignment_viewer.label_text_color .alignment_viewer.entry_text_color

    grid .alignment_viewer.aa_credits .alignment_viewer.save_ps\
	.alignment_viewer.ps_file .alignment_viewer.exit -pady 3
    #####################################
}

#######################
# Amino Acids Credits #
#######################
proc Show_AA_Credits {} {

    destroy .aa_credits
    set file_aa_credits [open "./Amino_Acids/Amino_Acids_Credits.txt" r]
    set text_aa_credits [read $file_aa_credits]
    close $file_aa_credits

    toplevel .aa_credits
    wm title .aa_credits "Amino Acids Credits"
    wm protocol .aa_credits WM_DELETE_WINDOW "destroy .aa_credits"

    button .aa_credits.dismiss -text "Dismiss" -bg gray \
           -command {destroy .aa_credits}
    label .aa_credits.text -text $text_aa_credits
    pack .aa_credits.text -pady 4 -padx 4 
    pack .aa_credits.dismiss -pady 3 -padx 3
}

###########
# WARNING #
###########
proc Show_Warning {} {

    destroy .inconvenience
    set file_warning [open "./Amino_Acids/Warning_Viewer.txt" r]
    set text_warning [read $file_warning]
    close $file_warning

    toplevel .inconvenience
    wm title .inconvenience "We Apologize"
    wm protocol .inconvenience WM_DELETE_WINDOW "destroy .inconvenience"

    button .inconvenience.dismiss -text "Dismiss" -bg gray \
           -command {destroy .inconvenience}
    label .inconvenience.text -text $text_warning 
    pack .inconvenience.text -pady 4 -padx 4 
    pack .inconvenience.dismiss -pady 3 -padx 3
}

###############################
# SHOW AMINO ACIDS PROCEDURES #
###############################
proc Show_AA_K {} {

    set amino_acid [image create photo -file ./Amino_Acids/lysin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/lys3d.gif]
    
    destroy .amino_acid_K
    toplevel .amino_acid_K

    wm title .amino_acid_K "About Amino Acids"
    wm protocol .amino_acid_K WM_DELETE_WINDOW "destroy .amino_acid_K"

    label .amino_acid_K.image -image $amino_acid -justify center
    label .amino_acid_K.image_3d -image $am_ac_3d -justify center
    button .amino_acid_K.dismiss -text "Dismiss" -command {destroy .amino_acid_K}

    grid .amino_acid_K.image -padx 6 -pady 3
    grid .amino_acid_K.image_3d -padx 6 -pady 3
    grid .amino_acid_K.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_H {} {

    set amino_acid [image create photo -file ./Amino_Acids/histidin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/his3d.gif]

    destroy .amino_acid_H
    toplevel .amino_acid_H

    wm title .amino_acid_H "About Amino Acids"
    wm protocol .amino_acid_H WM_DELETE_WINDOW "destroy .amino_acid_H"

    label .amino_acid_H.image -image $amino_acid -justify center
    label .amino_acid_H.image_3d -image $am_ac_3d -justify center
    button .amino_acid_H.dismiss -text "Dismiss" -command {destroy .amino_acid_H}

    grid .amino_acid_H.image -padx 6 -pady 3
    grid .amino_acid_H.image_3d -padx 6 -pady 3
    grid .amino_acid_H.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_T {} {

    set amino_acid [image create photo -file ./Amino_Acids/threonin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/thr3d.gif]

    destroy .amino_acid_T
    toplevel .amino_acid_T

    wm title .amino_acid_T "About Amino Acids"
    wm protocol .amino_acid_T WM_DELETE_WINDOW "destroy .amino_acid_T"

    label .amino_acid_T.image -image $amino_acid -justify center
    label .amino_acid_T.image_3d -image $am_ac_3d -justify center
    button .amino_acid_T.dismiss -text "Dismiss" -command {destroy .amino_acid_T}

    grid .amino_acid_T.image -padx 6 -pady 3
    grid .amino_acid_T.image_3d -padx 6 -pady 3
    grid .amino_acid_T.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_Q {} {

    set amino_acid [image create photo -file ./Amino_Acids/glutamin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/gln3d.gif]

    destroy .amino_acid_Q
    toplevel .amino_acid_Q

    wm title .amino_acid_Q "About Amino Acids"
    wm protocol .amino_acid_Q WM_DELETE_WINDOW "destroy .amino_acid_Q"

    label .amino_acid_Q.image -image $amino_acid -justify center
    label .amino_acid_Q.image_3d -image $am_ac_3d -justify center
    button .amino_acid_Q.dismiss -text "Dismiss" -command {destroy .amino_acid_Q}

    grid .amino_acid_Q.image -padx 6 -pady 3
    grid .amino_acid_Q.image_3d -padx 6 -pady 3
    grid .amino_acid_Q.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_E {} {

    set amino_acid [image create photo -file ./Amino_Acids/glu.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/glu3d.gif]

    destroy .amino_acid_E
    toplevel .amino_acid_E

    wm title .amino_acid_E "About Amino Acids"
    wm protocol .amino_acid_E WM_DELETE_WINDOW "destroy .amino_acid_E"

    label .amino_acid_E.image -image $amino_acid -justify center
    label .amino_acid_E.image_3d -image $am_ac_3d -justify center
    button .amino_acid_E.dismiss -text "Dismiss" -command {destroy .amino_acid_E}

    grid .amino_acid_E.image -padx 6 -pady 3
    grid .amino_acid_E.image_3d -padx 6 -pady 3
    grid .amino_acid_E.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_V {} {

    set amino_acid [image create photo -file ./Amino_Acids/valin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/val3d.gif]

    destroy .amino_acid_V
    toplevel .amino_acid_V

    wm title .amino_acid_V "About Amino Acids"
    wm protocol .amino_acid_V WM_DELETE_WINDOW "destroy .amino_acid_V"

    label .amino_acid_V.image -image $amino_acid -justify center
    label .amino_acid_V.image_3d -image $am_ac_3d -justify center
    button .amino_acid_V.dismiss -text "Dismiss" -command {destroy .amino_acid_V}

    grid .amino_acid_V.image -padx 6 -pady 3
    grid .amino_acid_V.image_3d -padx 6 -pady 3
    grid .amino_acid_V.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_L {} {

    set amino_acid [image create photo -file ./Amino_Acids/leucin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/leu3d.gif]

    destroy .amino_acid_L
    toplevel .amino_acid_L

    wm title .amino_acid_L "About Amino Acids"
    wm protocol .amino_acid_L WM_DELETE_WINDOW "destroy .amino_acid_L"

    label .amino_acid_L.image -image $amino_acid -justify center
    label .amino_acid_L.image_3d -image $am_ac_3d -justify center
    button .amino_acid_L.dismiss -text "Dismiss" -command {destroy .amino_acid_L}

    grid .amino_acid_L.image -padx 6 -pady 3
    grid .amino_acid_L.image_3d -padx 6 -pady 3
    grid .amino_acid_L.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_F {} {

    set amino_acid [image create photo -file ./Amino_Acids/phe.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/phe3d.gif]

    destroy .amino_acid_F
    toplevel .amino_acid_F

    wm title .amino_acid_F "About Amino Acids"
    wm protocol .amino_acid_F WM_DELETE_WINDOW "destroy .amino_acid_F"

    label .amino_acid_F.image -image $amino_acid -justify center
    label .amino_acid_F.image_3d -image $am_ac_3d -justify center
    button .amino_acid_F.dismiss -text "Dismiss" -command {destroy .amino_acid_F}

    grid .amino_acid_F.image -padx 6 -pady 3
    grid .amino_acid_F.image_3d -padx 6 -pady 3
    grid .amino_acid_F.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_W {} {

    set amino_acid [image create photo -file ./Amino_Acids/trp.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/trp3d.gif]

    destroy .amino_acid_W
    toplevel .amino_acid_W

    wm title .amino_acid_W "About Amino Acids"
    wm protocol .amino_acid_W WM_DELETE_WINDOW "destroy .amino_acid_W"

    label .amino_acid_W.image -image $amino_acid -justify center
    label .amino_acid_W.image_3d -image $am_ac_3d -justify center
    button .amino_acid_W.dismiss -text "Dismiss" -command {destroy .amino_acid_W}

    grid .amino_acid_W.image -padx 6 -pady 3
    grid .amino_acid_W.image_3d -padx 6 -pady 3
    grid .amino_acid_W.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_G {} {

    set amino_acid [image create photo -file ./Amino_Acids/glycin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/gly3d.gif]

    destroy .amino_acid_G
    toplevel .amino_acid_G

    wm title .amino_acid_G "About Amino Acids"
    wm protocol .amino_acid_G WM_DELETE_WINDOW "destroy .amino_acid_G"

    label .amino_acid_G.image -image $amino_acid -justify center
    label .amino_acid_G.image_3d -image $am_ac_3d -justify center
    button .amino_acid_G.dismiss -text "Dismiss" -command {destroy .amino_acid_G}

    grid .amino_acid_G.image -padx 6 -pady 3
    grid .amino_acid_G.image_3d -padx 6 -pady 3
    grid .amino_acid_G.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_R {} {

    set amino_acid [image create photo -file ./Amino_Acids/arginin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/arg3d.gif]

    destroy .amino_acid_R
    toplevel .amino_acid_R

    wm title .amino_acid_R "About Amino Acids"
    wm protocol .amino_acid_R WM_DELETE_WINDOW "destroy .amino_acid_R"

    label .amino_acid_R.image -image $amino_acid -justify center
    label .amino_acid_R.image_3d -image $am_ac_3d -justify center
    button .amino_acid_R.dismiss -text "Dismiss" -command {destroy .amino_acid_R}

    grid .amino_acid_R.image -padx 6 -pady 3
    grid .amino_acid_R.image_3d -padx 6 -pady 3
    grid .amino_acid_R.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_S {} {

    set amino_acid [image create photo -file ./Amino_Acids/serin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/ser3d.gif]

    destroy .amino_acid_S
    toplevel .amino_acid_S

    wm title .amino_acid_S "About Amino Acids"
    wm protocol .amino_acid_S WM_DELETE_WINDOW "destroy .amino_acid_S"

    label .amino_acid_S.image -image $amino_acid -justify center
    label .amino_acid_S.image_3d -image $am_ac_3d -justify center
    button .amino_acid_S.dismiss -text "Dismiss" -command {destroy .amino_acid_S}

    grid .amino_acid_S.image -padx 6 -pady 3
    grid .amino_acid_S.image_3d -padx 6 -pady 3
    grid .amino_acid_S.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_N {} {

    set amino_acid [image create photo -file ./Amino_Acids/asparagin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/asn3d.gif]

    destroy .amino_acid_N
    toplevel .amino_acid_N

    wm title .amino_acid_N "About Amino Acids"
    wm protocol .amino_acid_N WM_DELETE_WINDOW "destroy .amino_acid_N"

    label .amino_acid_N.image -image $amino_acid -justify center
    label .amino_acid_N.image_3d -image $am_ac_3d -justify center
    button .amino_acid_N.dismiss -text "Dismiss" -command {destroy .amino_acid_N}

    grid .amino_acid_N.image -padx 6 -pady 3
    grid .amino_acid_N.image_3d -padx 6 -pady 3
    grid .amino_acid_N.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_D {} {

    set amino_acid [image create photo -file ./Amino_Acids/asp.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/asp3d.gif]

    destroy .amino_acid_D
    toplevel .amino_acid_D

    wm title .amino_acid_D "About Amino Acids"
    wm protocol .amino_acid_D WM_DELETE_WINDOW "destroy .amino_acid_D"

    label .amino_acid_D.image -image $amino_acid -justify center
    label .amino_acid_D.image_3d -image $am_ac_3d -justify center
    button .amino_acid_D.dismiss -text "Dismiss" -command {destroy .amino_acid_D}

    grid .amino_acid_D.image -padx 6 -pady 3
    grid .amino_acid_D.image_3d -padx 6 -pady 3
    grid .amino_acid_D.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_A {} {

    set amino_acid [image create photo -file ./Amino_Acids/alanin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/ala3d.gif]

    destroy .amino_acid_A
    toplevel .amino_acid_A

    wm title .amino_acid_A "About Amino Acids"
    wm protocol .amino_acid_A WM_DELETE_WINDOW "destroy .amino_acid_A"

    label .amino_acid_A.image -image $amino_acid -justify center
    label .amino_acid_A.image_3d -image $am_ac_3d -justify center
    button .amino_acid_A.dismiss -text "Dismiss" -command {destroy .amino_acid_A}

    grid .amino_acid_A.image -padx 6 -pady 3
    grid .amino_acid_A.image_3d -padx 6 -pady 3
    grid .amino_acid_A.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_I {} {

    set amino_acid [image create photo -file ./Amino_Acids/ile.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/ile3d.gif]

    destroy .amino_acid_I
    toplevel .amino_acid_I

    wm title .amino_acid_I "About Amino Acids"
    wm protocol .amino_acid_I WM_DELETE_WINDOW "destroy .amino_acid_I"

    label .amino_acid_I.image -image $amino_acid -justify center
    label .amino_acid_I.image_3d -image $am_ac_3d -justify center
    button .amino_acid_I.dismiss -text "Dismiss" -command {destroy .amino_acid_I}

    grid .amino_acid_I.image -padx 6 -pady 3
    grid .amino_acid_I.image_3d -padx 6 -pady 3
    grid .amino_acid_I.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_M {} {
    
    set amino_acid [image create photo -file ./Amino_Acids/met.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/met3d.gif]

    destroy .amino_acid_M
    toplevel .amino_acid_M

    wm title .amino_acid_M "About Amino Acids"
    wm protocol .amino_acid_M WM_DELETE_WINDOW "destroy .amino_acid_M"

    label .amino_acid_M.image -image $amino_acid -justify center
    label .amino_acid_M.image_3d -image $am_ac_3d -justify center
    button .amino_acid_M.dismiss -text "Dismiss" -command {destroy .amino_acid_M}

    grid .amino_acid_M.image -padx 6 -pady 3
    grid .amino_acid_M.image_3d -padx 6 -pady 3
    grid .amino_acid_M.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_Y {} {

    set amino_acid [image create photo -file ./Amino_Acids/tyrosin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/tyr3d.gif]

    destroy .amino_acid_Y
    toplevel .amino_acid_Y

    wm title .amino_acid_Y "About Amino Acids"
    wm protocol .amino_acid_Y WM_DELETE_WINDOW "destroy .amino_acid_Y"

    label .amino_acid_Y.image -image $amino_acid -justify center
    label .amino_acid_Y.image_3d -image $am_ac_3d -justify center
    button .amino_acid_Y.dismiss -text "Dismiss" -command {destroy .amino_acid_Y}

    grid .amino_acid_Y.image -padx 6 -pady 3
    grid .amino_acid_Y.image_3d -padx 6 -pady 3
    grid .amino_acid_Y.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_C {} {

    set amino_acid [image create photo -file ./Amino_Acids/cystein.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/cys3d.gif]

    destroy .amino_acid_C
    toplevel .amino_acid_C

    wm title .amino_acid_C "About Amino Acids"
    wm protocol .amino_acid_C WM_DELETE_WINDOW "destroy .amino_acid_C"

    label .amino_acid_C.image -image $amino_acid -justify center
    label .amino_acid_C.image_3d -image $am_ac_3d -justify center
    button .amino_acid_C.dismiss -text "Dismiss" -command {destroy .amino_acid_C}

    grid .amino_acid_C.image -padx 6 -pady 3
    grid .amino_acid_C.image_3d -padx 6 -pady 3
    grid .amino_acid_C.dismiss -padx 6 -pady 3
}
###############################
proc Show_AA_P {} {

    set amino_acid [image create photo -file ./Amino_Acids/prolin.gif]
    set am_ac_3d [image create photo -file ./Amino_Acids/pro3d.gif]

    destroy .amino_acid_P
    toplevel .amino_acid_P

    wm title .amino_acid_P "About Amino Acids"
    wm protocol .amino_acid_P WM_DELETE_WINDOW "destroy .amino_acid_P"

    label .amino_acid_P.image -image $amino_acid -justify center
    label .amino_acid_P.image_3d -image $am_ac_3d -justify center
    button .amino_acid_P.dismiss -text "Dismiss" -command {destroy .amino_acid_P}

    grid .amino_acid_P.image -padx 6 -pady 3
    grid .amino_acid_P.image_3d -padx 6 -pady 3
    grid .amino_acid_P.dismiss -padx 6 -pady 3
}
###############################
proc Show_Color_Map_Canvas {} {

    global gene_color_black gene_color_blue gene_color_brown gene_color_cyan \
       gene_color_gold gene_color_gray gene_color_green gene_color_lightblue \
       gene_color_orange gene_color_pink gene_color_purple gene_color_salmon \
       gene_color_red gene_color_violet gene_color_white gene_color_yellow

    global canvas_background font_color_canvas default_outline_gene_color

    destroy .c_map
    toplevel .c_map

    wm title .c_map "GenomePixelizer ColorMap" 
    wm protocol .c_map WM_DELETE_WINDOW "destroy .c_map" 

    canvas .c_map.cp -width 360 -height 340 -bg $canvas_background

    # SIMPLE COLORS

    .c_map.cp create rect 10 10 20 20 -fill $gene_color_black -outline $default_outline_gene_color
    .c_map.cp create text 30 25 -text black -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 30 20 40 -fill $gene_color_blue -outline $default_outline_gene_color
    .c_map.cp create text 30 45 -text blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 50 20 60 -fill $gene_color_brown -outline $default_outline_gene_color
    .c_map.cp create text 30 65 -text brown -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 70 20 80 -fill $gene_color_cyan -outline $default_outline_gene_color
    .c_map.cp create text 30 85 -text cyan -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 90 20 100 -fill $gene_color_gray -outline $default_outline_gene_color
    .c_map.cp create text 30 105 -text gray -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 110 20 120 -fill $gene_color_green -outline $default_outline_gene_color
    .c_map.cp create text 30 125 -text green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 130 20 140 -fill $gene_color_lightblue -outline $default_outline_gene_color
    .c_map.cp create text 30 145 -text lightblue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 150 20 160 -fill $gene_color_orange -outline $default_outline_gene_color
    .c_map.cp create text 30 165 -text orange -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 170 20 180 -fill $gene_color_pink -outline $default_outline_gene_color
    .c_map.cp create text 30 185 -text pink -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 190 20 200 -fill $gene_color_purple -outline $default_outline_gene_color
    .c_map.cp create text 30 205 -text purple -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 210 20 220 -fill $gene_color_red -outline $default_outline_gene_color
    .c_map.cp create text 30 225 -text red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 230 20 240 -fill $gene_color_salmon -outline $default_outline_gene_color
    .c_map.cp create text 30 245 -text salmon -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 250 20 260 -fill $gene_color_violet -outline $default_outline_gene_color
    .c_map.cp create text 30 265 -text violet -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 270 20 280 -fill $gene_color_white -outline $default_outline_gene_color
    .c_map.cp create text 30 285 -text white -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 290 20 300 -fill $gene_color_yellow -outline $default_outline_gene_color
    .c_map.cp create text 30 305 -text yellow -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 10 310 20 320 -fill $gene_color_gray -outline $gene_color_red
    .c_map.cp create text 30 325 -text gray_red -anchor sw -fill $font_color_canvas

    # COMPLEX COLORS COLUMN A

    .c_map.cp create rect 110 10 120 20 -fill $gene_color_brown -outline $gene_color_gold
    .c_map.cp create text 130 25 -text brown_gold -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 30 120 40 -fill $gene_color_white -outline $gene_color_red
    .c_map.cp create text 130 45 -text white_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 50 120 60 -fill $gene_color_white -outline $gene_color_blue
    .c_map.cp create text 130 65 -text white_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 70 120 80 -fill $gene_color_white -outline $gene_color_green
    .c_map.cp create text 130 85 -text white_green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 90 120 100 -fill $gene_color_yellow -outline $gene_color_red
    .c_map.cp create text 130 105 -text yellow_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 110 120 120 -fill $gene_color_yellow -outline $gene_color_blue
    .c_map.cp create text 130 125 -text yellow_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 130 120 140 -fill $gene_color_yellow -outline $gene_color_green
    .c_map.cp create text 130 145 -text yellow_green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 150 120 160 -fill $gene_color_black -outline $gene_color_red
    .c_map.cp create text 130 165 -text black_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 170 120 180 -fill $gene_color_black -outline $gene_color_orange
    .c_map.cp create text 130 185 -text black_orange -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 190 120 200 -fill $gene_color_black -outline $gene_color_cyan
    .c_map.cp create text 130 205 -text black_cyan -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 210 120 220 -fill $gene_color_black -outline $gene_color_green
    .c_map.cp create text 130 225 -text black_green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 230 120 240 -fill $gene_color_blue -outline $gene_color_green
    .c_map.cp create text 130 245 -text blue_green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 250 120 260 -fill $gene_color_blue -outline $gene_color_orange
    .c_map.cp create text 130 265 -text blue_orange -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 270 120 280 -fill $gene_color_lightblue -outline $gene_color_blue
    .c_map.cp create text 130 285 -text lightblue_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 290 120 300 -fill $gene_color_gold -outline $gene_color_cyan
    .c_map.cp create text 130 305 -text gold_cyan -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 110 310 120 320 -fill $gene_color_green -outline $gene_color_red
    .c_map.cp create text 130 325 -text green_red -anchor sw -fill $font_color_canvas

    # COMPLEX COLORS COLUMN B

    .c_map.cp create rect 250 10 260 20 -fill $gene_color_orange -outline $gene_color_red
    .c_map.cp create text 270 25 -text orange_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 30 260 40 -fill $gene_color_orange -outline $gene_color_blue
    .c_map.cp create text 270 45 -text orange_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 50 260 60 -fill $gene_color_orange -outline $gene_color_purple
    .c_map.cp create text 270 65 -text orange_purple -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 70 260 80 -fill $gene_color_cyan -outline $gene_color_red
    .c_map.cp create text 270 85 -text cyan_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 90 260 100 -fill $gene_color_cyan -outline $gene_color_blue
    .c_map.cp create text 270 105 -text cyan_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 110 260 120 -fill $gene_color_cyan -outline $gene_color_green
    .c_map.cp create text 270 125 -text cyan_green -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 130 260 140 -fill $gene_color_violet -outline $gene_color_red
    .c_map.cp create text 270 145 -text violet_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 150 260 160 -fill $gene_color_violet -outline $gene_color_purple
    .c_map.cp create text 270 165 -text violet_purple -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 170 260 180 -fill $gene_color_violet -outline $gene_color_blue
    .c_map.cp create text 270 185 -text violet_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 190 260 200 -fill $gene_color_pink -outline $gene_color_red
    .c_map.cp create text 270 205 -text pink_red -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 210 260 220 -fill $gene_color_pink -outline $gene_color_purple
    .c_map.cp create text 270 225 -text pink_purple -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 230 260 240 -fill $gene_color_green -outline $gene_color_blue
    .c_map.cp create text 270 245 -text green_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 250 260 260 -fill $gene_color_gray -outline $gene_color_blue
    .c_map.cp create text 270 265 -text gray_blue -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 270 260 280 -fill $gene_color_white -outline $gene_color_gray
    .c_map.cp create text 270 285 -text white_gray -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 290 260 300 -fill $gene_color_white -outline $gene_color_gold
    .c_map.cp create text 270 305 -text white_gold -anchor sw -fill $font_color_canvas

    .c_map.cp create rect 250 310 260 320 -fill $gene_color_green -outline $gene_color_gold
    .c_map.cp create text 270 325 -text green_gold -anchor sw -fill $font_color_canvas

    button .c_map.dismiss -text "Dismiss" -command {destroy .c_map}
    pack .c_map.cp .c_map.dismiss -padx 4 -pady 4
}

proc Canvas_Editor {} {

    destroy .c_editor
    toplevel .c_editor

    wm title .c_editor "Canvas Editor" 
    wm protocol .c_editor WM_DELETE_WINDOW "destroy .c_editor"
    wm minsize .c_editor 512 285

    global selected_canvas \
	font_color_canvas \
	font_color_label \
	canvas_editor_font_type \
	canvas_editor_font_size \
	canvas_editor_font_style \
	text_tag \
	canvas_editor_text \
	curX curY 

    set font_color_label $font_color_canvas
    set selected_canvas ".genpix.canvas"
    set canvas_editor_text "my lovely gene"
    set canvas_editor_font_type "helvetica"
    set canvas_editor_font_size 12
    set canvas_editor_font_style normal
    set text_tag text_tag_01
    set curX 125
    set curY 125

    global graph_style \
	graph_tag \
	graphX1 graphX2 \
	graphY1 graphY2 \
	graph_fill_color \
	graph_outline_color

    set graph_style "rect"
    set graph_tag "graph_tag_01"
    set graphX1 100 
    set graphY1 100
    set graphX2 24
    set graphY2 12
    set graph_fill_color "cyan"
    set graph_outline_color "blue"

    ###########################################################################

    label .c_editor.select_text_label -text "select text:" -bg yellow3 -width 12
    place .c_editor.select_text_label -x 10 -y 10

    entry .c_editor.select_text_entry -relief sunken \
	    -textvariable canvas_editor_text -bg gold -width 22
    place .c_editor.select_text_entry -x 105 -y 10

    label .c_editor.select_canvas -text "select canvas:" -bg gray -width 14
    place .c_editor.select_canvas -x 280 -y 10

    entry .c_editor.select_canvas_entry -relief sunken \
	    -textvariable selected_canvas -bg lightblue -width 15
    place .c_editor.select_canvas_entry -x 390 -y 10

    ########################

    label .c_editor.text_color_label -text "text color:" -bg gray -width 12
    place .c_editor.text_color_label -x 10 -y 40

    entry .c_editor.text_color_entry -relief sunken \
	    -textvariable font_color_label -bg lightyellow -width 20
    place .c_editor.text_color_entry -x 105 -y 40

    label .c_editor.select_graph_label -text "Graphical Label:" -bg yellow3 -width 18
    place .c_editor.select_graph_label -x 330 -y 40

    ########################

    label .c_editor.text_type_label -text "font type:" -bg gray -width 12
    place .c_editor.text_type_label -x 10 -y 70

    entry .c_editor.text_type_entry -relief sunken \
	    -textvariable canvas_editor_font_type -bg lightyellow -width 20
    place .c_editor.text_type_entry -x 105 -y 70

    label .c_editor.graph_style_label -text "shape:" -bg gray -width 12
    place .c_editor.graph_style_label -x 300 -y 70

    entry .c_editor.graph_style_entry -relief sunken \
	    -textvariable graph_style -bg lightyellow -width 14
    place .c_editor.graph_style_entry -x 395 -y 70

    ########################

    label .c_editor.text_size_label -text "font size:" -bg gray -width 12
    place .c_editor.text_size_label -x 10 -y 100

    entry .c_editor.text_size_entry -relief sunken \
	    -textvariable canvas_editor_font_size -bg lightyellow -width 20
    place .c_editor.text_size_entry -x 105 -y 100

    label .c_editor.graph_fill_label -text "fill:" -bg gray -width 12
    place .c_editor.graph_fill_label -x 300 -y 100

    entry .c_editor.graph_fill_entry -relief sunken \
	    -textvariable graph_fill_color -bg lightyellow -width 14
    place .c_editor.graph_fill_entry -x 395 -y 100

    ########################

    label .c_editor.text_style_label -text "font style:" -bg gray -width 12
    place .c_editor.text_style_label -x 10 -y 130

    entry .c_editor.text_style_entry -relief sunken \
	    -textvariable canvas_editor_font_style -bg lightyellow -width 20
    place .c_editor.text_style_entry -x 105 -y 130

    label .c_editor.graph_outline_label -text "outline:" -bg gray -width 12
    place .c_editor.graph_outline_label -x 300 -y 130

    entry .c_editor.graph_outline_entry -relief sunken \
	    -textvariable graph_outline_color -bg lightyellow -width 14
    place .c_editor.graph_outline_entry -x 395 -y 130

    ########################

    label .c_editor.current_X_label -text "current X:" -bg gray -width 12
    place .c_editor.current_X_label -x 10 -y 160

    label .c_editor.current_Y_label -text "current Y:" -bg gray -width 12
    place .c_editor.current_Y_label -x 10 -y 190

    entry .c_editor.current_X_entry -relief sunken \
	    -textvariable curX -bg lightyellow -width 20
    place .c_editor.current_X_entry -x 105 -y 160

    entry .c_editor.current_Y_entry -relief sunken \
	    -textvariable curY -bg lightyellow -width 20
    place .c_editor.current_Y_entry -x 105 -y 190

    label .c_editor.graphX1 -text "X1" -bg gray -width 4
    place .c_editor.graphX1 -x 300 -y 160

    label .c_editor.graphY1 -text "Y1" -bg gray -width 4
    place .c_editor.graphY1 -x 300 -y 190

    label .c_editor.graphX2 -text "X2" -bg gray -width 4
    place .c_editor.graphX2 -x 400 -y 160

    label .c_editor.graphY2 -text "Y2" -bg gray -width 4
    place .c_editor.graphY2 -x 400 -y 190

    entry .c_editor.graphX1_entry -relief sunken \
	    -textvariable graphX1 -bg lightyellow -width 6
    place .c_editor.graphX1_entry -x 340 -y 160

    entry .c_editor.graphY1_entry -relief sunken \
	    -textvariable graphY1 -bg lightyellow -width 6
    place .c_editor.graphY1_entry -x 340 -y 190

    entry .c_editor.graphX2_entry -relief sunken \
	    -textvariable graphX2 -bg lightyellow -width 6
    place .c_editor.graphX2_entry -x 440 -y 160

    entry .c_editor.graphY2_entry -relief sunken \
	    -textvariable graphY2 -bg lightyellow -width 6
    place .c_editor.graphY2_entry -x 440 -y 190

    ########################

    label .c_editor.tag_ID_label -text "active tag ID:" -bg yellow3 -width 12
    place .c_editor.tag_ID_label -x 10 -y 220

    entry .c_editor.tag_ID_entry -relief sunken \
	    -textvariable text_tag -bg gold -width 20
    place .c_editor.tag_ID_entry -x 105 -y 220

    label .c_editor.graph_ID_label -text "active tag ID:" -bg yellow3 -width 12
    place .c_editor.graph_ID_label -x 300 -y 220

    entry .c_editor.graph_ID_entry -relief sunken \
	    -textvariable graph_tag -bg gold -width 14
    place .c_editor.graph_ID_entry -x 395 -y 220

    ########################

    button .c_editor.submit_text -text "Add Text to Canvas" \
	    -command {Place_Text_on_Canvas} -bg orange -width 17
    place .c_editor.submit_text -x 20 -y 250

    button .c_editor.submit_graphics -text "Add Label to Canvas" \
	    -command {Add_Graphics_to_Canvas} -bg orange -width 17
    place .c_editor.submit_graphics -x 350 -y 250

    button .c_editor.how_to -text "HowTo" \
	    -command {How_To_Edit_Canvas} -bg gray -width 6
    place .c_editor.how_to -x 185 -y 250

    button .c_editor.dismiss -text "Dismiss" \
	    -command {destroy .c_editor} -bg gray -width 6
    place .c_editor.dismiss -x 265 -y 250
}

proc Print_Gene_ID {gene_id} {

    set is_it_here [winfo exists .c_editor]
    if {$is_it_here == 0} {
	Canvas_Editor
    }

    global selected_canvas text_tag \
	curX curY canvas_editor_text \
	font_color_canvas font_color_label \
	canvas_editor_font_type \
	canvas_editor_font_size \
	canvas_editor_font_style

    $selected_canvas bind $text_tag <Enter> {
	set curX [expr int(round([$selected_canvas canvasx %x]))]
	set curY [expr int(round([$selected_canvas canvasy %y]))]
    }

    $selected_canvas create text [expr $curX + 3] [expr $curY - 3] -text "$gene_id" \
	    -font "$canvas_editor_font_type $canvas_editor_font_size $canvas_editor_font_style" \
	    -anchor sw -fill $font_color_label -tags "$text_tag this_is_a_label"

    $selected_canvas bind $text_tag <Button-1> {
	set curX [expr int(round([$selected_canvas canvasx %x]))]
	set curY [expr int(round([$selected_canvas canvasy %y]))]
    }
    $selected_canvas bind $text_tag <Button-3> {
	Delete_Text_Item
    }

    $selected_canvas bind $text_tag <B1-Motion> {
	Move_Text_Label [$selected_canvas find withtag current] \
	[expr [expr int(round([$selected_canvas canvasx %x]))] - $curX] \
	[expr [expr int(round([$selected_canvas canvasy %y]))] - $curY]
    set curX [expr int(round([$selected_canvas canvasx %x]))]
    set curY [expr int(round([$selected_canvas canvasy %y]))]
    }     
}

proc Move_Text_Label { node xDist yDist } {

    global selected_canvas curX curY

    $selected_canvas move $node $xDist $yDist
    incr curX $xDist
    incr curY $yDist
}

proc Move_Graph_Label { node xDist1 yDist1 } {

    global selected_canvas \
	graphX1 graphX2 \
	graphY1 graphY2

    $selected_canvas move $node $xDist1 $yDist1
    incr graphX1 $xDist1
    incr graphY1 $yDist1
    # incr graphX2 $xDist1
    # incr graphY2 $yDist1
}

proc Place_Text_on_Canvas {} {

    global selected_canvas text_tag \
	curX curY canvas_editor_text \
	font_color_canvas font_color_label \
	canvas_editor_font_type \
	canvas_editor_font_size \
	canvas_editor_font_style

    $selected_canvas create text $curX $curY -text "$canvas_editor_text" \
	    -font "$canvas_editor_font_type $canvas_editor_font_size $canvas_editor_font_style" \
	    -anchor sw -fill $font_color_label -tags "$text_tag this_is_a_label"

    $selected_canvas bind $text_tag <Button-1> {
	set curX [expr int(round([$selected_canvas canvasx %x]))]
	set curY [expr int(round([$selected_canvas canvasy %y]))]
    }
    $selected_canvas bind $text_tag <Button-3> {
	Delete_Text_Item
    }

    $selected_canvas bind $text_tag <B1-Motion> {
	Move_Text_Label [$selected_canvas find withtag current] \
	[expr [expr int(round([$selected_canvas canvasx %x]))] - $curX] \
	[expr [expr int(round([$selected_canvas canvasy %y]))] - $curY]
    set curX [expr int(round([$selected_canvas canvasx %x]))]
    set curY [expr int(round([$selected_canvas canvasy %y]))]
    }
}

proc Add_Graphics_to_Canvas {} {

    global	graph_style \
	    graph_tag \
	    graphX1 graphX2 \
	    graphY1 graphY2 \
	    graph_fill_color \
	    graph_outline_color \
	    selected_canvas

    $selected_canvas create $graph_style $graphX1 $graphY1 \
	[expr $graphX1 + $graphX2] \
	[expr $graphY1 + $graphY2] \
	-fill $graph_fill_color -outline $graph_outline_color -tags "$graph_tag this_is_a_label"

    $selected_canvas bind $graph_tag <Button-1> {
    set graphX1 [expr int(round([$selected_canvas canvasx %x]))]
    set graphY1 [expr int(round([$selected_canvas canvasy %y]))]
    }

    $selected_canvas bind $graph_tag <Button-3> {
	Delete_Graph_Item
    }

    $selected_canvas bind $graph_tag <B1-Motion> {
	Move_Graph_Label [$selected_canvas find withtag current] \
	[expr [expr int(round([$selected_canvas canvasx %x]))] - $graphX1] \
	[expr [expr int(round([$selected_canvas canvasy %y]))] - $graphY1] 
    set graphX1 [expr int(round([$selected_canvas canvasx %x]))]
    set graphY1 [expr int(round([$selected_canvas canvasy %y]))]
    }
}

# DELETE TEXT ITEM
proc Delete_Text_Item {} {

    global selected_canvas text_tag

    toplevel .delete_item
    wm title .delete_item "WARNING!" 
    wm protocol .delete_item WM_DELETE_WINDOW "destroy .delete_item"

    label .delete_item.text -text "Do you really want to delete 
all labels with tag ID: 

$text_tag\?"

    pack .delete_item.text -padx 7 -pady 7

    button .delete_item.yes -text "Yes" -command {Destroy_Text_and_Dismiss} \
	    -bg orange -width 4
    button .delete_item.no -text "No" -command "destroy .delete_item" \
	    -bg lightblue -width 4

    pack .delete_item.yes -padx 3 -pady 3
    pack .delete_item.no -padx 3 -pady 3
}

proc Destroy_Text_and_Dismiss {} {
    global selected_canvas text_tag
    $selected_canvas delete $text_tag
    destroy .delete_item
}

# DELETE GRAPH ITEM
proc Delete_Graph_Item {} {

    global selected_canvas graph_tag

    toplevel .delete_graph_item
    wm title .delete_graph_item "WARNING!" 
    wm protocol .delete_graph_item WM_DELETE_WINDOW "destroy .delete_graph_item"

    label .delete_graph_item.text -text "Do you really want to delete 
all labels with tag ID: 

$graph_tag\?"

    pack .delete_graph_item.text -padx 7 -pady 7

    button .delete_graph_item.yes -text "Yes" -command {Destroy_Graph_and_Dismiss} \
	    -bg orange -width 4
    button .delete_graph_item.no -text "No" -command "destroy .delete_graph_item" \
	    -bg lightblue -width 4

    pack .delete_graph_item.yes -padx 3 -pady 3
    pack .delete_graph_item.no -padx 3 -pady 3
}

proc Destroy_Graph_and_Dismiss {} {
    global selected_canvas graph_tag
    $selected_canvas delete $graph_tag
    destroy .delete_graph_item
}

proc How_To_Edit_Canvas {} {

    destroy .how_to_edit_canvas
    toplevel .how_to_edit_canvas
    wm title .how_to_edit_canvas "Canvas Editing HowTo" 
    wm protocol .how_to_edit_canvas WM_DELETE_WINDOW "destroy .how_to_edit_canvas"

    label .how_to_edit_canvas.text -text "
By using this Canvas Editor you may edit and finish your 
project(s) by adding text and graphical labels over the 
image generated by GenomePixelizer or Alignment Viewer. 
By left-button mouse click you may move the text and 
labels over GenomePixelizer canvas. By middle-button
mouse click you may print gene IDs on canvas.
By right-button mouse click you may delete the text 
and labels you don't need. 

Select canvas \".genpix.canvas\" to edit 
GenomePixelizer image or \".c.alignment\" to edit 
the image generated by Alignment Viewer.
"
    button .how_to_edit_canvas.dismiss -text "Dismiss" \
	-command "destroy .how_to_edit_canvas" -bg gray -width 8

    pack .how_to_edit_canvas.text -padx 7 -pady 7
    pack .how_to_edit_canvas.dismiss -padx 3 -pady 3
}

proc Matrix_Validator {} {

    global matrix_to_validate input_file_to_check validated_matrix

    destroy .matrix_validator
    toplevel .matrix_validator
    wm title .matrix_validator "Matrix Validator" 
    wm protocol .matrix_validator WM_DELETE_WINDOW "destroy .matrix_validator"
    wm minsize .matrix_validator 440 180

    set matrix_to_validate "./Tutorial/GenPix_Tutorial_Matrix_bad"
    set input_file_to_check "./Tutorial/GenPix_Tutorial_Input"
    set validated_matrix "./Tutorial/GenPix_Tutorial_Matrix_good"

    label .matrix_validator.matrix_bad_label -text "matrix to check:" -bg yellow3 -width 18
    place .matrix_validator.matrix_bad_label -x 10 -y 10

    entry .matrix_validator.matrix_bad_entry -relief sunken \
	    -textvariable matrix_to_validate -bg gold -width 38
    place .matrix_validator.matrix_bad_entry -x 150 -y 10

    label .matrix_validator.input_file_label -text "compare with file:" -bg yellow3 -width 18
    place .matrix_validator.input_file_label -x 10 -y 40

    entry .matrix_validator.input_file_entry -relief sunken \
	    -textvariable input_file_to_check -bg gold -width 38
    place .matrix_validator.input_file_entry -x 150 -y 40

    label .matrix_validator.matrix_good_label -text "validated matrix:" -bg yellow3 -width 18
    place .matrix_validator.matrix_good_label -x 10 -y 70

    entry .matrix_validator.matrix_good_entry -relief sunken \
	    -textvariable validated_matrix -bg gold -width 38
    place .matrix_validator.matrix_good_entry -x 150 -y 70

    button .matrix_validator.do_it -text "Check it!" -width 8 -height 2 \
	    -bg orange -fg blue4 -command {Check_Bad_Matrix_New}
    place .matrix_validator.do_it -x 20 -y 120

    button .matrix_validator.how_to -text "How To\nValidate" -width 8 -height 2 \
	    -bg gray -fg black -command {How_To_Validate_Matrix}
    place .matrix_validator.how_to -x 180 -y 120

    button .matrix_validator.dismiss -text "Dismiss" -width 8 -height 2 \
	    -bg gray -fg black -command {destroy .matrix_validator}
    place .matrix_validator.dismiss -x 340 -y 120
}

##################################

proc Check_Bad_Matrix_New {} {

    Be_Patient_Matrix

    global matrix_to_validate input_file_to_check \
	    validated_matrix 

    set input_file_to_open [open "$input_file_to_check" "r"]
    set seq_IDs_list ""

    while {[gets $input_file_to_open current_line] >= 0}  {
	set current_seq_ID [lindex $current_line 1]
	set seq_IDs_list [lappend seq_IDs_list "$current_seq_ID"]
	# puts $seq_IDs_list
    }
    close $input_file_to_open
    Check_Bad_Matrix_Step2 $seq_IDs_list
}

proc Check_Bad_Matrix_Step2 { seq_IDs_list } {

    global matrix_to_validate input_file_to_check \
	    validated_matrix

    set matrix_file_to_write [open "$validated_matrix" "w"]
    set matrix_file_to_open [open "$matrix_to_validate" "r"]

    while {[gets $matrix_file_to_open matrix_current_line] >= 0}  {
	set matrix_ID_A [lindex $matrix_current_line 0]
	set matrix_ID_B [lindex $matrix_current_line 1]
	set is_it_here_A [lsearch -exact $seq_IDs_list $matrix_ID_A]
	set is_it_here_B [lsearch -exact $seq_IDs_list $matrix_ID_B]
	if {$is_it_here_A >=0 && $is_it_here_B >=0} {
	    puts $matrix_file_to_write $matrix_current_line
	}
	update
    }
    bell
    close $matrix_file_to_write
    close $matrix_file_to_open
    Matrix_Validation_Done
    puts "Done!"
}

##################################
proc Check_Bad_Matrix_A {} {

    Be_Patient_Matrix

    global matrix_to_validate input_file_to_check \
	    validated_matrix matrix_file_temporay_to_open

    set matrix_file_temporay "temporary_matrix_file.genopix"
    set input_file_to_open [open "$input_file_to_check" "r"]
    set matrix_file_to_write [open "$validated_matrix" "w"]
    set matrix_file_temporay_to_open [open "$matrix_file_temporay" "w"]

    while {[gets $input_file_to_open current_line] >= 0}  {

	set current_seq_ID [lindex $current_line 1]
	Compare_with_Matrix_A $current_seq_ID $matrix_file_to_write
    }
    close $input_file_to_open
    close $matrix_file_to_write
    close $matrix_file_temporay_to_open
    Check_Bad_Matrix_B
}

proc Compare_with_Matrix_A { current_seq_ID matrix_file_to_write } {

    global matrix_to_validate input_file_to_check \
	    validated_matrix matrix_file_temporay_to_open

    set matrix_file_to_open [open "$matrix_to_validate" "r"]

    while {[gets $matrix_file_to_open matrix_current_line] >= 0}  {
	set matrix_ID_A [lindex $matrix_current_line 0]
	set matrix_ID_B [lindex $matrix_current_line 1]
	set matrix_dist [lindex $matrix_current_line 2]
	set matrix_colr [lindex $matrix_current_line 3]

	if {"$current_seq_ID" == "$matrix_ID_A"} {
	    puts -nonewline "$matrix_file_temporay_to_open" \
		    "$matrix_ID_A\t$matrix_ID_B\t$matrix_dist\t$matrix_colr\n"
	} else {
	    continue
	}
	update
    }
    close $matrix_file_to_open
}

proc Check_Bad_Matrix_B {} {

    global matrix_to_validate input_file_to_check \
	    validated_matrix matrix_file_temporay_to_open

    set input_file_to_open [open "$input_file_to_check" "r"]
    set matrix_file_to_write [open "$validated_matrix" "w"]

    while {[gets $input_file_to_open current_line] >= 0}  {

	set current_seq_ID [lindex $current_line 1]
	Compare_with_Matrix_B $current_seq_ID $matrix_file_to_write
    }
    file delete -force "temporary_matrix_file.genopix"
    close $input_file_to_open
    close $matrix_file_to_write
    Matrix_Validation_Done
    puts "Done!"
}

proc Compare_with_Matrix_B { current_seq_ID matrix_file_to_write } {

    global matrix_to_validate input_file_to_check \
	    validated_matrix matrix_file_temporay_to_open

    set matrix_file_temporay "temporary_matrix_file.genopix"
    set matrix_file_temporay_to_open [open "$matrix_file_temporay" "r"]

    while {[gets $matrix_file_temporay_to_open matrix_current_line] >= 0}  {
	set matrix_ID_A [lindex $matrix_current_line 0]
	set matrix_ID_B [lindex $matrix_current_line 1]
	set matrix_dist [lindex $matrix_current_line 2]
	set matrix_colr [lindex $matrix_current_line 3]

	if {"$current_seq_ID" == "$matrix_ID_B"} {
	    puts -nonewline "$matrix_file_to_write" \
		    "$matrix_ID_A\t$matrix_ID_B\t$matrix_dist\t$matrix_colr\n"
	} else {
	    continue
	}
	update
    }
    close $matrix_file_temporay_to_open
}

proc How_To_Validate_Matrix {} {

    destroy .how_to_matrix_validator
    toplevel .how_to_matrix_validator
    wm title .how_to_matrix_validator "How To Validate Matrix" 
    wm protocol .how_to_matrix_validator WM_DELETE_WINDOW "destroy .how_to_matrix_validator"

    label .how_to_matrix_validator.text -text "
Matrix file MAY NOT contain gene ID(s) that are not in 
Input file with gene coordinates. Otherwise you may get 
wrong line drawing. Despite of this very simple demand it 
is almost impossible to set up the matrix file without 
errors or misprints. For this reason GenomePixelizer has 
the \"Matrix Validator\" procedure that may help to set up 
your matrix file properly. This procedure may compare gene
ID(s) from the Input file to gene ID(s) from Matrix file 
and remove all gene ID(s) from Matrix file that are not
in the Input file, and create new valid Matrix file with 
proper gene ID(s) for given Input file. Fill corresponding
entries for Matrix, Input and validated Matrix files and 
click \"Check it\" to validate Matrix file. 
"
    grid .how_to_matrix_validator.text -padx 3 -pady 3

    button .how_to_matrix_validator.dismiss -text "Dismiss" \
	-command {destroy .how_to_matrix_validator}
    grid .how_to_matrix_validator.dismiss -padx 3 -pady 3
}

proc Be_Patient_Matrix {} {
    destroy .patient_matrix
    set be_patient_text "be patient, processing data"
    toplevel .patient_matrix
    wm transient .patient_matrix .
    wm title .patient_matrix "be patient"
    wm protocol .patient_matrix WM_DELETE_WINDOW "destroy .patient_matrix"
    label .patient_matrix.text -text $be_patient_text -justify center -bg orange
    pack .patient_matrix.text -padx 12 -pady 12 
}

proc Matrix_Validation_Done {} {

    destroy .patient_matrix
    set be_patient_text "Done!"
    toplevel .patient_matrix
    wm transient .patient_matrix .
    wm title .patient_matrix "Done!"
    wm protocol .patient_matrix WM_DELETE_WINDOW "destroy .patient_matrix"
    label .patient_matrix.text -text "$be_patient_text" \
	    -justify center -bg black -fg orange
    pack .patient_matrix.text -padx 12 -pady 12 
    bell ; after 10000 destroy .patient_matrix
}

proc Locus_Zoomer {} {

    global sub_project_file_setup sub_project_file_coord sub_project_file_matrix
    global sub_project_coord_to_process sub_project_matrix_to_process
    global sub_project_chrm_A sub_project_chrm_A_left sub_project_chrm_A_right
    global sub_project_chrm_B sub_project_chrm_B_left sub_project_chrm_B_right
    global sub_project_chrm_A_order sub_project_chrm_B_order ruler_scale_value

    destroy .locus_zoomer
    toplevel .locus_zoomer
    wm title .locus_zoomer "Locus Zoomer"
    wm protocol .locus_zoomer WM_DELETE_WINDOW "destroy .locus_zoomer"
    wm minsize .locus_zoomer 410 310

    set sub_project_file_setup "./Projects/locus_zoomer_setup.txt"
    set sub_project_file_coord "./Projects/locus_zoomer_coord.txt"
    set sub_project_file_matrix "./Projects/locus_zoomer_matrix.txt"

    set sub_project_coord_to_process "./Tutorial/GenPix_Tutorial_Input"
    set sub_project_matrix_to_process "./Tutorial/GenPix_Tutorial_Matrix"

    # set sub_project_coord_to_process "./Arabidopsis_Genome/arabidopsis_all_genes_coord.txt"
    # set sub_project_matrix_to_process "./Arabidopsis_Genome/arabidopsis_all_genes_matrix.txt"

    set sub_project_chrm_A "1"
    set sub_project_chrm_B "2"
    set sub_project_chrm_A_left "4"
    set sub_project_chrm_A_right "8"
    set sub_project_chrm_B_left "8"
    set sub_project_chrm_B_right "12"
    set sub_project_chrm_A_order "FOR"
    set sub_project_chrm_B_order "REV"
    set ruler_scale_value "10"

    #####################################

    label .locus_zoomer.sub_prj_file_label -text "file setup:" -bg gray -width 12
    place .locus_zoomer.sub_prj_file_label -x 10 -y 10

    entry .locus_zoomer.sub_prj_file_entry -relief sunken \
	    -textvariable sub_project_file_setup -bg lightyellow -width 40
    place .locus_zoomer.sub_prj_file_entry -x 105 -y 10

    #####################################

    label .locus_zoomer.sub_prj_coord_label -text "coord setup:" -bg gray -width 12
    place .locus_zoomer.sub_prj_coord_label -x 10 -y 40

    entry .locus_zoomer.sub_prj_coord_entry -relief sunken \
	    -textvariable sub_project_file_coord -bg lightyellow -width 40
    place .locus_zoomer.sub_prj_coord_entry -x 105 -y 40

    #####################################

    label .locus_zoomer.sub_prj_matrix_label -text "matrix setup:" -bg gray -width 12
    place .locus_zoomer.sub_prj_matrix_label -x 10 -y 70

    entry .locus_zoomer.sub_prj_matrix_entry -relief sunken \
	    -textvariable sub_project_file_matrix -bg lightyellow -width 40
    place .locus_zoomer.sub_prj_matrix_entry -x 105 -y 70

    #####################################

    label .locus_zoomer.sub_prj_all_coord_label -text "coords orig:" -bg gray -width 12
    place .locus_zoomer.sub_prj_all_coord_label -x 10 -y 100

    entry .locus_zoomer.sub_prj_all_coord_entry -relief sunken \
	    -textvariable sub_project_coord_to_process -bg lightblue -width 40
    place .locus_zoomer.sub_prj_all_coord_entry -x 105 -y 100

    #####################################

    label .locus_zoomer.sub_prj_total_matrix_label -text "matrix orig:" -bg gray -width 12
    place .locus_zoomer.sub_prj_total_matrix_label -x 10 -y 130

    entry .locus_zoomer.sub_prj_total_matrix_entry -relief sunken \
	    -textvariable sub_project_matrix_to_process -bg lightblue -width 40
    place .locus_zoomer.sub_prj_total_matrix_entry -x 105 -y 130

    #####################################

    label .locus_zoomer.chrm_A_label -text "chrm A:" -bg gray -width 12
    place .locus_zoomer.chrm_A_label -x 105 -y 160

    entry .locus_zoomer.chrm_A_entry -relief sunken \
	    -textvariable sub_project_chrm_A -bg gold -width 5
    place .locus_zoomer.chrm_A_entry -x 200 -y 160

    #####################################

    label .locus_zoomer.chrm_B_label -text "chrm B:" -bg gray -width 12
    place .locus_zoomer.chrm_B_label -x 255 -y 160

    entry .locus_zoomer.chrm_B_entry -relief sunken \
	    -textvariable sub_project_chrm_B -bg gold -width 5
    place .locus_zoomer.chrm_B_entry -x 350 -y 160

    #####################################

    label .locus_zoomer.chrm_A_left_label -text "left coord A:" -bg gray -width 12
    place .locus_zoomer.chrm_A_left_label -x 105 -y 190

    entry .locus_zoomer.chrm_A_left_entry -relief sunken \
	    -textvariable sub_project_chrm_A_left -bg gold -width 5
    place .locus_zoomer.chrm_A_left_entry -x 200 -y 190

    #####################################

    label .locus_zoomer.chrm_A_right_label -text "right coord A:" -bg gray -width 12
    place .locus_zoomer.chrm_A_right_label -x 105 -y 220

    entry .locus_zoomer.chrm_A_right_entry -relief sunken \
	    -textvariable sub_project_chrm_A_right -bg gold -width 5
    place .locus_zoomer.chrm_A_right_entry -x 200 -y 220

    #####################################

    label .locus_zoomer.chrm_B_left_label -text "left coord B:" -bg gray -width 12
    place .locus_zoomer.chrm_B_left_label -x 255 -y 190

    entry .locus_zoomer.chrm_B_left_entry -relief sunken \
	    -textvariable sub_project_chrm_B_left -bg gold -width 5
    place .locus_zoomer.chrm_B_left_entry -x 350 -y 190

    #####################################

    label .locus_zoomer.chrm_B_right_label -text "right coord B:" -bg gray -width 12
    place .locus_zoomer.chrm_B_right_label -x 255 -y 220

    entry .locus_zoomer.chrm_B_right_entry -relief sunken \
	    -textvariable sub_project_chrm_B_right -bg gold -width 5
    place .locus_zoomer.chrm_B_right_entry -x 350 -y 220

    #####################################

    label .locus_zoomer.chrm_A_order_label -text "order A:" -bg gray -width 12
    place .locus_zoomer.chrm_A_order_label -x 105 -y 250

    entry .locus_zoomer.chrm_A_order_entry -relief sunken \
	    -textvariable sub_project_chrm_A_order -bg gold -width 5
    place .locus_zoomer.chrm_A_order_entry -x 200 -y 250

    label .locus_zoomer.chrm_B_order_label -text "order B:" -bg gray -width 12
    place .locus_zoomer.chrm_B_order_label -x 255 -y 250

    entry .locus_zoomer.chrm_B_order_entry -relief sunken \
	    -textvariable sub_project_chrm_B_order -bg gold -width 5
    place .locus_zoomer.chrm_B_order_entry -x 350 -y 250

    #####################################

    label .locus_zoomer.scale_value_label -text "Ruler Scale Value:" -bg gray -width 18
    place .locus_zoomer.scale_value_label -x 210 -y 280

    entry .locus_zoomer.scale_value_entry -relief sunken \
	    -textvariable ruler_scale_value -bg lightblue -width 5
    place .locus_zoomer.scale_value_entry -x 350 -y 280

    #####################################

    button .locus_zoomer.do_it -text "Generate\nNew\nProject" -bg brown \
	    -fg gold -height 3 -command {Generate_Sub_Project}
    place .locus_zoomer.do_it -x 12 -y 170

    #####################################

    button .locus_zoomer.howto -text "HowTo" -bg gray -width 8 -command {HowTo_Create_SubProject}
    place .locus_zoomer.howto -x 12 -y 235

    button .locus_zoomer.dismiss -text "Dismiss" -bg gray -width 8 -command {destroy .locus_zoomer}
    place .locus_zoomer.dismiss -x 12 -y 273
}

proc Generate_Sub_Project {} {

    global sub_project_file_setup sub_project_file_coord sub_project_file_matrix
    global sub_project_coord_to_process sub_project_matrix_to_process
    global sub_project_chrm_A sub_project_chrm_A_left sub_project_chrm_A_right
    global sub_project_chrm_B sub_project_chrm_B_left sub_project_chrm_B_right
    global sub_project_chrm_A_order sub_project_chrm_B_order ruler_scale_value

    set sub_input_coord_open [open $sub_project_coord_to_process "r"]
    set sub_output_coord_open [open $sub_project_file_coord "w"]
    while {[gets $sub_input_coord_open current_line_coord] >= 0} {
	set chrm_data [lindex [split $current_line_coord "\t"] 0]
	set gene_data [lindex [split $current_line_coord "\t"] 1]
	set coord_data [lindex [split $current_line_coord "\t"] 2]
	set wc_data [lindex [split $current_line_coord "\t"] 3]
	set color_data [lindex [split $current_line_coord "\t"] 4]
	set size_data [lindex [split $current_line_coord "\t"] 5]
	if {$sub_project_chrm_A == $chrm_data && $coord_data >= $sub_project_chrm_A_left && $coord_data <= $sub_project_chrm_A_right && $sub_project_chrm_A_order == "FOR"} {
	    set coord_data [expr $coord_data - $sub_project_chrm_A_left]
	    set scaled_coord_data [expr $coord_data*$ruler_scale_value]
	    set first_chrm "1"
	    puts $sub_output_coord_open $first_chrm\t$gene_data\t$scaled_coord_data\t$wc_data\t$color_data\t$size_data
	}
	if {$sub_project_chrm_B == $chrm_data && $coord_data >= $sub_project_chrm_B_left && $coord_data <= $sub_project_chrm_B_right && $sub_project_chrm_B_order == "FOR"} {
	    set coord_data [expr $coord_data - $sub_project_chrm_B_left]
	    set scaled_coord_data [expr $coord_data*$ruler_scale_value]
	    set second_chrm "3"
	    puts $sub_output_coord_open $second_chrm\t$gene_data\t$scaled_coord_data\t$wc_data\t$color_data\t$size_data
	}	
	if {$sub_project_chrm_A == $chrm_data && $coord_data >= $sub_project_chrm_A_left && $coord_data <= $sub_project_chrm_A_right && $sub_project_chrm_A_order == "REV"} {
	    set coord_data [expr $sub_project_chrm_A_right - $coord_data]
	    set scaled_coord_data [expr $coord_data*$ruler_scale_value]
	    set first_chrm "1"
	    puts $sub_output_coord_open $first_chrm\t$gene_data\t$scaled_coord_data\t$wc_data\t$color_data\t$size_data
	}
	if {$sub_project_chrm_B == $chrm_data && $coord_data >= $sub_project_chrm_B_left && $coord_data <= $sub_project_chrm_B_right && $sub_project_chrm_B_order == "REV"} {
	    set coord_data [expr $sub_project_chrm_B_right - $coord_data]
	    set scaled_coord_data [expr $coord_data*$ruler_scale_value]
	    set second_chrm "3"
	    puts $sub_output_coord_open $second_chrm\t$gene_data\t$scaled_coord_data\t$wc_data\t$color_data\t$size_data
	}	
    }
    close $sub_input_coord_open
    close $sub_output_coord_open
    Sub_Project_Matrix
}

proc Sub_Project_Matrix {} {

    global matrix_to_validate input_file_to_check \
	    validated_matrix 
	    
    global sub_project_file_setup sub_project_file_coord \
	    sub_project_file_matrix sub_project_matrix_to_process

    global sub_project_chrm_A_left sub_project_chrm_A_right
    global sub_project_chrm_B_left sub_project_chrm_B_right

    global ruler_scale_value

    set size_A [expr ($sub_project_chrm_A_right - $sub_project_chrm_A_left)*$ruler_scale_value]
    set size_B [expr ($sub_project_chrm_B_right - $sub_project_chrm_B_left)*$ruler_scale_value]

    set matrix_to_validate $sub_project_matrix_to_process
    set input_file_to_check $sub_project_file_coord
    set validated_matrix $sub_project_file_matrix

    Check_Bad_Matrix_New

    #### Generate Sub-project Run Setup file ####
    set sub_project_file_setup_open [open $sub_project_file_setup "w"]
    puts $sub_project_file_setup_open "1. name of file containing gene coordinates: $sub_project_file_coord"
    puts $sub_project_file_setup_open "2. name of the distance matrix file: $sub_project_file_matrix"
    puts $sub_project_file_setup_open "3. number of chromosomes: 3"
    puts $sub_project_file_setup_open "4. size of chromosomes: $size_A 0 $size_B"
    puts $sub_project_file_setup_open "5. identity upper level: 100"
    puts $sub_project_file_setup_open "6. identity lower level: 40"
    puts $sub_project_file_setup_open "7. window size (pixels) X: 800"
    puts $sub_project_file_setup_open "8. window size (pixels) Y: 600"
    puts $sub_project_file_setup_open "9. html prefix: http://whatever.you.want/garfield_db/"
    puts $sub_project_file_setup_open "10. Title: Your Great Sub-Project, 40% identity"
    puts $sub_project_file_setup_open "11. Laboratory: (Your Famous Lab)"
    puts $sub_project_file_setup_open "########################################################"
    puts $sub_project_file_setup_open "#####   for experienced users below this line   ########"
    puts $sub_project_file_setup_open "12. W/C correction: A"
    puts $sub_project_file_setup_open "13. horizontal size of gene: 7"
    puts $sub_project_file_setup_open "14. vertical size of gene: 5"
    puts $sub_project_file_setup_open "15. W/C coefficient: 1"
    puts $sub_project_file_setup_open "16. W/C correction value: 7"
    puts $sub_project_file_setup_open "17. chromosome thickness: 5"
    puts $sub_project_file_setup_open "18. gene feature mode (standard \[std\] or extended \[ext\]): std"

    close $sub_project_file_setup_open
}

proc HowTo_Create_SubProject {} {

    destroy .how_to_subprj
    toplevel .how_to_subprj
    wm title .how_to_subprj "HowTo Create Sub Project" 
    wm protocol .how_to_subprj WM_DELETE_WINDOW "destroy .how_to_subprj"

    label .how_to_subprj.text -text "
GenomePixelizer can automatically create 
sub - project based on data of large project.
For example, you are interested in relationship
between genes only for one given duplicated 
locus. You need to specify chromosome 
coordinates for regions of interest for 
chromosomes A and B, names of files that will 
be generated and location of original project 
files containing gene coordinates and distance 
matrix file. By clicking on \"Generate New Project\", 
program will extract all needed data from 
original files and create new input files 
with data only for specified loci.
"
    button .how_to_subprj.dismiss -text "Dismiss" \
	-command "destroy .how_to_subprj" -bg gray -width 8

    pack .how_to_subprj.text -padx 7 -pady 7
    pack .how_to_subprj.dismiss -padx 3 -pady 3
}

proc Node_Painter {} {

    destroy .node_painter
    toplevel .node_painter
    wm title .node_painter "Gene Painter"
    wm protocol .node_painter WM_DELETE_WINDOW "destroy .node_painter"
    wm minsize .node_painter 465 230
    # .node_painter config -bg black

    global nodes_group1 nodes_group2 nodes_group3
    global nodes_group4 nodes_group5 nodes_group6

    set nodes_group1 "./Group/my_group1.txt"
    set nodes_group2 "./Group/my_group2.txt"
    set nodes_group3 "./Group/my_group3.txt"
    set nodes_group4 "./Group/my_group4.txt"
    set nodes_group5 "./Group/my_group5.txt"
    set nodes_group6 "./Group/my_group6.txt"

    global color_group1 color_group2 color_group3 
    global color_group4 color_group5 color_group6
    global color_group1_outline color_group2_outline color_group3_outline 
    global color_group4_outline color_group5_outline color_group6_outline

    set color_group1 orange
    set color_group2 green
    set color_group3 blue
    set color_group4 purple
    set color_group5 red
    set color_group6 black

    set color_group1_outline orange
    set color_group2_outline green
    set color_group3_outline blue
    set color_group4_outline purple
    set color_group5_outline red
    set color_group6_outline black

    #####
    label .node_painter.select_group1_label -text "group1:" -bg gray -width 12
    place .node_painter.select_group1_label -x 10 -y 10

    entry .node_painter.select_group1_entry -relief sunken \
	    -textvariable nodes_group1 -bg lightyellow -width 20
    place .node_painter.select_group1_entry -x 105 -y 10

    entry .node_painter.color_group1_entry -relief sunken \
	    -textvariable color_group1 -bg lightyellow -width 8
    place .node_painter.color_group1_entry -x 260 -y 10

    entry .node_painter.color_group1_outline_entry -relief sunken \
	    -textvariable color_group1_outline -bg lightyellow -width 8
    place .node_painter.color_group1_outline_entry -x 330 -y 10

    button .node_painter.paint_group1 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color1}
    place .node_painter.paint_group1 -x 400 -y 8
    #####
    label .node_painter.select_group2_label -text "group2:" -bg gray -width 12
    place .node_painter.select_group2_label -x 10 -y 40

    entry .node_painter.select_group2_entry -relief sunken \
	    -textvariable nodes_group2 -bg lightyellow -width 20
    place .node_painter.select_group2_entry -x 105 -y 40

    entry .node_painter.color_group2_entry -relief sunken \
	    -textvariable color_group2 -bg lightyellow -width 8
    place .node_painter.color_group2_entry -x 260 -y 40

    entry .node_painter.color_group2_outline_entry -relief sunken \
	    -textvariable color_group2_outline -bg lightyellow -width 8
    place .node_painter.color_group2_outline_entry -x 330 -y 40

    button .node_painter.paint_group2 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color2}
    place .node_painter.paint_group2 -x 400 -y 38
    #####
    label .node_painter.select_group3_label -text "group3:" -bg gray -width 12
    place .node_painter.select_group3_label -x 10 -y 70

    entry .node_painter.select_group3_entry -relief sunken \
	    -textvariable nodes_group3 -bg lightyellow -width 20
    place .node_painter.select_group3_entry -x 105 -y 70

    entry .node_painter.color_group3_entry -relief sunken \
	    -textvariable color_group3 -bg lightyellow -width 8
    place .node_painter.color_group3_entry -x 260 -y 70

    entry .node_painter.color_group3_outline_entry -relief sunken \
	    -textvariable color_group3_outline -bg lightyellow -width 8
    place .node_painter.color_group3_outline_entry -x 330 -y 70

    button .node_painter.paint_group3 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color3}
    place .node_painter.paint_group3 -x 400 -y 68
    #####
    label .node_painter.select_group4_label -text "group4:" -bg gray -width 12
    place .node_painter.select_group4_label -x 10 -y 100

    entry .node_painter.select_group4_entry -relief sunken \
	    -textvariable nodes_group4 -bg lightyellow -width 20
    place .node_painter.select_group4_entry -x 105 -y 100

    entry .node_painter.color_group4_entry -relief sunken \
	    -textvariable color_group4 -bg lightyellow -width 8
    place .node_painter.color_group4_entry -x 260 -y 100

    entry .node_painter.color_group4_outline_entry -relief sunken \
	    -textvariable color_group4_outline -bg lightyellow -width 8
    place .node_painter.color_group4_outline_entry -x 330 -y 100

    button .node_painter.paint_group4 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color4}
    place .node_painter.paint_group4 -x 400 -y 98
    #####
    label .node_painter.select_group5_label -text "group5:" -bg gray -width 12
    place .node_painter.select_group5_label -x 10 -y 130

    entry .node_painter.select_group5_entry -relief sunken \
	    -textvariable nodes_group5 -bg lightyellow -width 20
    place .node_painter.select_group5_entry -x 105 -y 130

    entry .node_painter.color_group5_entry -relief sunken \
	    -textvariable color_group5 -bg lightyellow -width 8
    place .node_painter.color_group5_entry -x 260 -y 130

    entry .node_painter.color_group5_outline_entry -relief sunken \
	    -textvariable color_group5_outline -bg lightyellow -width 8
    place .node_painter.color_group5_outline_entry -x 330 -y 130

    button .node_painter.paint_group5 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color5}
    place .node_painter.paint_group5 -x 400 -y 128
    #####
    label .node_painter.select_group6_label -text "group6:" -bg gray -width 12
    place .node_painter.select_group6_label -x 10 -y 160

    entry .node_painter.select_group6_entry -relief sunken \
	    -textvariable nodes_group6 -bg lightyellow -width 20
    place .node_painter.select_group6_entry -x 105 -y 160

    entry .node_painter.color_group6_entry -relief sunken \
	    -textvariable color_group6 -bg lightyellow -width 8
    place .node_painter.color_group6_entry -x 260 -y 160

    entry .node_painter.color_group6_outline_entry -relief sunken \
	    -textvariable color_group6_outline -bg lightyellow -width 8
    place .node_painter.color_group6_outline_entry -x 330 -y 160

    button .node_painter.paint_group6 -text "paint" -bg yellow3 \
	    -command {Change_Node_Color6}
    place .node_painter.paint_group6 -x 400 -y 158
    #####

    label .node_painter.fill_color -text "fill" -bg gray -width 8
    place .node_painter.fill_color -x 260 -y 185

    label .node_painter.outline_color -text "outline" -bg gray -width 8
    place .node_painter.outline_color -x 330 -y 185

    #####
    button .node_painter.howto -text "HowTo" -bg gray -width 8 -command {HowTo_Paint_Nodes}
    place .node_painter.howto -x 20 -y 195

    button .node_painter.dismiss -text "Dismiss" -bg gray -width 8 -command {destroy .node_painter}
    place .node_painter.dismiss -x 140 -y 195
}

proc HowTo_Paint_Nodes {} {

    destroy .how_to_paint
    toplevel .how_to_paint
    wm title .how_to_paint "HowTo Paint Genes" 
    wm protocol .how_to_paint WM_DELETE_WINDOW "destroy .how_to_paint"

    label .how_to_paint.text -text "
To paint genes in different colors you need
to set up lists of genes belonging to distinct 
groups and place them in \"Group\" directory. 
By clicking \"paint\" program changes color 
of genes in a given list.
"
    button .how_to_paint.dismiss -text "Dismiss" \
	-command "destroy .how_to_paint" -bg gray -width 8

    pack .how_to_paint.text -padx 7 -pady 7
    pack .how_to_paint.dismiss -padx 3 -pady 3
}

proc Change_Node_Color1 {} {
    global nodes_group1 color_group1 color_group1_outline abc_tag
    set open_current_group [open $nodes_group1 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group1 -outline $color_group1_outline
    }
    close $open_current_group
    bell
}
proc Change_Node_Color2 {} {
    global nodes_group2 color_group2 color_group2_outline abc_tag
    set open_current_group [open $nodes_group2 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group2 -outline $color_group2_outline
    }
    close $open_current_group
    bell
}
proc Change_Node_Color3 {} {
    global nodes_group3 color_group3 color_group3_outline abc_tag
    set open_current_group [open $nodes_group3 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group3 -outline $color_group3_outline
    }
    close $open_current_group
    bell
}
proc Change_Node_Color4 {} {
    global nodes_group4 color_group4 color_group4_outline abc_tag
    set open_current_group [open $nodes_group4 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group4 -outline $color_group4_outline
    }
    close $open_current_group
    bell
}
proc Change_Node_Color5 {} {
    global nodes_group5 color_group5 color_group5_outline abc_tag
    set open_current_group [open $nodes_group5 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group5 -outline $color_group5_outline
    }
    close $open_current_group
    bell
}
proc Change_Node_Color6 {} {
    global nodes_group6 color_group6 color_group6_outline abc_tag
    set open_current_group [open $nodes_group6 "r"]
    while {[gets $open_current_group current_line_group] >= 0} {
	.genpix.canvas itemconfigure $abc_tag$current_line_group \
		-fill $color_group6 -outline $color_group6_outline
    }
    close $open_current_group
    bell
}

proc Fine_Matrix_Color {} {

    destroy .fine_matrix_color
    toplevel .fine_matrix_color
    wm title .fine_matrix_color "Matrix Color Tuner" 
    wm protocol .fine_matrix_color WM_DELETE_WINDOW "destroy .fine_matrix_color"
    wm minsize .fine_matrix_color 440 260
    .fine_matrix_color config -bg blue4

    global level_of_similarity_1 level_of_similarity_2 level_of_similarity_3
    global level_of_similarity_4 level_of_similarity_5 level_of_similarity_6

    global color_of_similarity_1 color_of_similarity_2 color_of_similarity_3
    global color_of_similarity_4 color_of_similarity_5 color_of_similarity_6

    set level_of_similarity_1 0.90
    set level_of_similarity_2 0.80
    set level_of_similarity_3 0.70
    set level_of_similarity_4 0.60
    set level_of_similarity_5 0.50
    set level_of_similarity_6 0.40

    set color_of_similarity_1 gray10
    set color_of_similarity_2 gray20
    set color_of_similarity_3 gray30
    set color_of_similarity_4 gray40
    set color_of_similarity_5 gray50
    set color_of_similarity_6 gray60

    label .fine_matrix_color.info_matrix -text \
"by opening this window
you override all color
settings for lines that
show relationship in
the matrix file. 
This window shows 
the current color 
scheme. By closing
this window you 
return back to 
original palette." \
-bg gray25 -fg gold -width 21
    place .fine_matrix_color.info_matrix -x 265 -y 40

    label .fine_matrix_color.identity_color_map -text "Relationship Color Map:" \
	-bg gray25 -fg gray80 -width 30
    place .fine_matrix_color.identity_color_map -x 30 -y 10

    label .fine_matrix_color.level_1 -text "1" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_1 -x 12 -y 40

    label .fine_matrix_color.level_0 -text "1.0 -" -bg gray25 -fg white -width 5
    place .fine_matrix_color.level_0 -x 45 -y 40

    entry .fine_matrix_color.level_1_entry -relief sunken -textvariable level_of_similarity_1 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_1_entry -x 100 -y 40

    entry .fine_matrix_color.color_1 -relief sunken -textvariable color_of_similarity_1 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_1 -x 170 -y 40
    ###
    label .fine_matrix_color.level_2 -text "2" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_2 -x 12 -y 70

    entry .fine_matrix_color.level_1a_entry -relief sunken -textvariable level_of_similarity_1 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_1a_entry -x 45 -y 70

    entry .fine_matrix_color.level_2_entry -relief sunken -textvariable level_of_similarity_2 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_2_entry -x 100 -y 70

    entry .fine_matrix_color.color_2 -relief sunken -textvariable color_of_similarity_2 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_2 -x 170 -y 70
    ###
    label .fine_matrix_color.level_3 -text "3" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_3 -x 12 -y 100

    entry .fine_matrix_color.level_2a_entry -relief sunken -textvariable level_of_similarity_2 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_2a_entry -x 45 -y 100

    entry .fine_matrix_color.level_3_entry -relief sunken -textvariable level_of_similarity_3 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_3_entry -x 100 -y 100

    entry .fine_matrix_color.color_3 -relief sunken -textvariable color_of_similarity_3 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_3 -x 170 -y 100
    ###
    label .fine_matrix_color.level_4 -text "4" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_4 -x 12 -y 130

    entry .fine_matrix_color.level_3a_entry -relief sunken -textvariable level_of_similarity_3 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_3a_entry -x 45 -y 130

    entry .fine_matrix_color.level_4_entry -relief sunken -textvariable level_of_similarity_4 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_4_entry -x 100 -y 130

    entry .fine_matrix_color.color_4 -relief sunken -textvariable color_of_similarity_4 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_4 -x 170 -y 130
    ###
    label .fine_matrix_color.level_5 -text "5" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_5 -x 12 -y 160

    entry .fine_matrix_color.level_4a_entry -relief sunken -textvariable level_of_similarity_4 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_4a_entry -x 45 -y 160

    entry .fine_matrix_color.level_5_entry -relief sunken -textvariable level_of_similarity_5 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_5_entry -x 100 -y 160

    entry .fine_matrix_color.color_5 -relief sunken -textvariable color_of_similarity_5 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_5 -x 170 -y 160
    ###
    label .fine_matrix_color.level_6 -text "6" -bg gray25 -fg gray80 -width 2
    place .fine_matrix_color.level_6 -x 12 -y 190

    entry .fine_matrix_color.level_5a_entry -relief sunken -textvariable level_of_similarity_5 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_5a_entry -x 45 -y 190

    entry .fine_matrix_color.level_6_entry -relief sunken -textvariable level_of_similarity_6 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_6_entry -x 100 -y 190

    entry .fine_matrix_color.color_6 -relief sunken -textvariable color_of_similarity_6 \
	-bg gray25 -fg white -width 10 -insertbackground lightyellow
    place .fine_matrix_color.color_6 -x 170 -y 190
    ###
    label .fine_matrix_color.level_7 -text "not defined below:" -bg gray25 -fg gray80 -width 17
    place .fine_matrix_color.level_7 -x 12 -y 223

    entry .fine_matrix_color.level_6a_entry -relief sunken -textvariable level_of_similarity_6 \
	-bg gray25 -fg white -width 5 -insertbackground lightyellow
    place .fine_matrix_color.level_6a_entry -x 150 -y 221

    button .fine_matrix_color.dismiss -text "Dismiss" \
	    -command {destroy .fine_matrix_color} -bg gray -width 7
    place .fine_matrix_color.dismiss -x 310 -y 210

}

proc Lower_Idnt_Lines {} {
    puts "Lower line"

    .genpix.canvas lower "identity_tag"
    .genpix.canvas lower "chromosome_tag"
    .genpix.canvas lower "dummy_background"

    bell
}

proc Rise_Idnt_Lines {} {
    puts "Rise lines"

    .genpix.canvas raise "identity_tag"
    .genpix.canvas raise "this_is_a_label"

    bell
}

proc Update_Canvas_Color {} {

    global gene_color_black gene_color_blue gene_color_brown gene_color_cyan \
	gene_color_gold gene_color_gray gene_color_green gene_color_lightblue \
	gene_color_orange gene_color_pink gene_color_purple gene_color_salmon \
	gene_color_red gene_color_violet gene_color_white gene_color_yellow

    global chromosome_color chromosome_outline canvas_background \
	default_outline_gene_color default_familyColor

    global font_color_canvas

    # UPDATE GENE COLORS #

    .genpix.canvas itemconfigure fillblack -fill $gene_color_black
    .genpix.canvas itemconfigure outlineblack -outline $gene_color_black

    .genpix.canvas itemconfigure fillblue -fill $gene_color_blue
    .genpix.canvas itemconfigure outlineblue -outline $gene_color_blue

    .genpix.canvas itemconfigure fillbrown -fill $gene_color_brown
    .genpix.canvas itemconfigure outlinebrown -outline $gene_color_brown

    .genpix.canvas itemconfigure fillcyan -fill $gene_color_cyan
    .genpix.canvas itemconfigure outlinecyan -outline $gene_color_cyan

    .genpix.canvas itemconfigure fillgold -fill $gene_color_gold
    .genpix.canvas itemconfigure outlinegold -outline $gene_color_gold

    .genpix.canvas itemconfigure fillgray -fill $gene_color_gray
    .genpix.canvas itemconfigure outlinegray -outline $gene_color_gray

    .genpix.canvas itemconfigure fillgreen -fill $gene_color_green
    .genpix.canvas itemconfigure outlinegreen -outline $gene_color_green

    .genpix.canvas itemconfigure filllightblue -fill $gene_color_lightblue
    .genpix.canvas itemconfigure outlinelightblue -outline $gene_color_lightblue

    .genpix.canvas itemconfigure fillorange -fill $gene_color_orange
    .genpix.canvas itemconfigure outlineorange -outline $gene_color_orange

    .genpix.canvas itemconfigure fillpink -fill $gene_color_pink
    .genpix.canvas itemconfigure outlinepink -outline $gene_color_pink

    .genpix.canvas itemconfigure fillpurple -fill $gene_color_purple
    .genpix.canvas itemconfigure outlinepurple -outline $gene_color_purple

    .genpix.canvas itemconfigure fillred -fill $gene_color_red
    .genpix.canvas itemconfigure outlinered -outline $gene_color_red

    .genpix.canvas itemconfigure fillsalmon -fill $gene_color_salmon
    .genpix.canvas itemconfigure outlinesalmon -outline $gene_color_salmon

    .genpix.canvas itemconfigure fillviolet -fill $gene_color_violet
    .genpix.canvas itemconfigure outlineviolet -outline $gene_color_violet

    .genpix.canvas itemconfigure fillwhite -fill $gene_color_white
    .genpix.canvas itemconfigure outlinewhite -outline $gene_color_white

    .genpix.canvas itemconfigure fillyellow -fill $gene_color_yellow
    .genpix.canvas itemconfigure outlineyellow -outline $gene_color_yellow

    # UPDATE IDENTITY COLORS #
    .genpix.canvas itemconfigure identityblue -fill $default_familyColor

    # UPDATE CHROMOSOME COLOR #
    .genpix.canvas itemconfigure dummy_background -fill $canvas_background
    .genpix.canvas itemconfigure chromosome_tag -fill $chromosome_color -outline $chromosome_outline

    # UPDATE TEXT AND RULER COLORS #
    .genpix.canvas itemconfigure this_is_a_text -fill $font_color_canvas
    .genpix.canvas itemconfigure this_is_a_ruler -fill $font_color_canvas

    bell
}

proc Canvas_Magic {} {
    destroy .canvas_magic_man
    toplevel .canvas_magic_man
    wm title .canvas_magic_man "Canvas Manipulator" 
    wm protocol .canvas_magic_man WM_DELETE_WINDOW "destroy .canvas_magic_man"
    wm minsize .canvas_magic_man 440 260
    # .canvas_magic_man config -bg blue4

    set lower_idn_lines_text "
If gene on canvas is completely covered by 
identity lines then it is hard to get mouse 
click event working well to print gene IDs 
on canvas. If you click on \"Lower\" button 
then all identity lines become below of genes 
and you can click on any gene to print their 
IDs without problems. By clicking on \"Rise\" 
button all identity lines become above genes 
as on original drawing. 

\"Update\" button changes the color scheme of 
genes and chromosomes on canvas dynamically 
according to values on main GP window. 
Also, this function resets a color scheme of 
the results by keyword search.
"

    label .canvas_magic_man.lower_idn_lines_lab -text $lower_idn_lines_text
    place .canvas_magic_man.lower_idn_lines_lab -x 10 -y 10

    button .canvas_magic_man.lower_idn_lines_act -text "Lower" \
	-command {Lower_Idnt_Lines} -bg gray -width 7
    place .canvas_magic_man.lower_idn_lines_act -x 340 -y 20

    button .canvas_magic_man.rise_idn_lines_act -text "Rise" \
	-command {Rise_Idnt_Lines} -bg gray -width 7
    place .canvas_magic_man.rise_idn_lines_act -x 340 -y 70

    button .canvas_magic_man.update_color -text "Update\n(Color Reset)" \
	-command {Update_Canvas_Color} -bg gray -width 12
    place .canvas_magic_man.update_color -x 320 -y 160

    button .canvas_magic_man.dismiss -text "Dismiss" \
	-command {destroy .canvas_magic_man} -bg gray -width 7
    place .canvas_magic_man.dismiss -x 340 -y 210
}

##########################################
#                                        # 
####  END OF THE LIST OF PROCEDURES  #####
#                                        #
##########################################

##########################################
#             ---------                  #   
##########    MAIN BODY    ###############
#             ---------                  #  
##########################################

###################################################
#        GenomePixelizer Main Window              #
###################################################

wm title . "GenomePixelizer"
wm protocol . WM_DELETE_WINDOW "destroy ."
wm minsize . 520 435
# . config -bg gray60

set gen_pix_banner_big [image create photo -height 61 -width 300 \
-file ./Images/GenoPix_Banner_big.gif]

label .gen_pix_logo -image $gen_pix_banner_big -bg lightblue
place .gen_pix_logo -x 25 -y 12

###########################################
# FOR COMPATIBILITY WITH PEVIOUS VERSION: #

    global fat_chr size_of_gene vertical_size_of_gene \
	    wc_coefficient wc_corr_value

    set fat_chr 5
    set size_of_gene 7
    set vertical_size_of_gene 4
    set wc_coefficient 1
    set wc_corr_value 6
    set gene_feature_mode "std"

#         END OF COMPATIBILITY            #
###########################################

###################################################
#           RunSetup File Entry                   #
###################################################
global input_file
set input_file "GenPix_RunSetup.txt"
label .project_label -text "RunSetup File:" -justify right -bg yellow3 -width 14
entry .input_runsetup -relief sunken -textvariable input_file -bg white -width 24
place .project_label -x 10 -y 97
place .input_runsetup -x 115 -y 97

button .startup -text "Run" -command {Genome_Pixelizer_Canvas} -bg orange
place .startup -x 295 -y 93

button .tutorial -text "Tutorial" -command {GenPix_Tutorial_00} -bg violet -width 7
place .tutorial -x 355 -y 8

button .documentation -text "Help" -command {Show_Documentation} -bg violet -width 7
place .documentation -x 435 -y 8

button .about -text "About" -command {About_GenPix} -bg violet -width 7
place .about -x 355 -y 38

button .bug_report -text "Feedback" -bg violet -width 7 -command {Show_Feedback}
place .bug_report -x 435 -y 38

button .color_map -text "ColorMap" -width 7 -bg gray -command {Show_Color_Map_Canvas}
place .color_map -x 355 -y 68

button .exit -text "Exit" -command {destroy .} -bg gray -width 7
place .exit -x 435 -y 68

button .node_editor -text "Gene Painter" -command {Node_Painter} \
	-bg gray -fg black -width 15 -height 1
place .node_editor -x 370 -y 98


##############################################

set ps_file_to_save genopix_canvas.ps

button .save_ps -text "Make PostScript" -bg brown -fg gold -width 13 \
-command {.genpix.canvas postscript -height $vertical_size -width $horizontal_size \
	      -x -1 -y 0 -file $ps_file_to_save; bell} 

entry .ps_file -relief sunken -textvariable ps_file_to_save -bg yellow3 -width 18

place .save_ps -x 83 -y 339
place .ps_file -x 203 -y 342

button .matrix_color_tuner -text "Matrix\nColor\nTuner" -bg gray -fg black -width 6 \
-command {Fine_Matrix_Color}

place .matrix_color_tuner -x 10 -y 310

##############################################

label .supplement_bg -bg gray70 -width 69 -height 4
place .supplement_bg -x 12 -y 370

# label .supplement -text "Supplemental  Packages:" -bg gray80 -fg blue4 -width 68
# place .supplement -x 16 -y 358

set text_locus_zoomer "Locus\nZoomer"
button .locus_zoomer_button -text "$text_locus_zoomer" \
	-command {Locus_Zoomer} -width 8 -height 2 -bg gray
place .locus_zoomer_button -x 16 -y 382

set text_matrix_validator "Matrix\nValidator"
button .matrix_validator_button -text "$text_matrix_validator" \
	-command {Matrix_Validator} -width 8 -height 2 -bg gray
place .matrix_validator_button -x 116 -y 382

set text_canvas_editor "Canvas\nEditor"
button .canvas_editor -text "$text_canvas_editor" \
	-command {Canvas_Editor} -width 8 -height 2 -bg gray
place .canvas_editor -x 216 -y 382

set text_canvas_magic "Canvas\nManipulator"
button .canvas_magic -text "$text_canvas_magic" \
	-command {Canvas_Magic} -width 8 -height 2 -bg gray
place .canvas_magic -x 316 -y 382

set text_alignment_viewer "Alignment\nViewer"
button .alignment -text "$text_alignment_viewer" \
	-command {View_the_Alignment} -width 8 -height 2 -bg gray
place .alignment -x 416 -y 382

# set text_about_supplement "About\nSupplement"
# button .supplement_packages -text "$text_about_supplement" \
# 	-command {About_Supplement} -width 8 -height 2 -bg gray
# place .supplement_packages -x 416 -y 382

####################
# COLOR DEFINITION #

global gene_color_black gene_color_blue gene_color_brown gene_color_cyan \
       gene_color_gold gene_color_gray gene_color_green gene_color_lightblue \
       gene_color_orange gene_color_pink gene_color_purple gene_color_salmon \
       gene_color_red gene_color_violet gene_color_white gene_color_yellow \
       outline_gene_color

set gene_color_black "black"
set gene_color_blue "blue"
set gene_color_brown "brown"
set gene_color_cyan "cyan"
set gene_color_gold "gold"
set gene_color_gray "gray"
set gene_color_green "green"
set gene_color_lightblue "lightblue"
set gene_color_orange "orange"
set gene_color_pink "pink"
set gene_color_purple "purple"
set gene_color_red "red"
set gene_color_salmon "salmon"
set gene_color_violet "violet"
set gene_color_white "white"
set gene_color_yellow "yellow"

label .color_definition -text "Gene  Features  Color  Map:" -bg gray -fg blue4 -width 67
place .color_definition -x 20 -y 130

###########################################

label .gene_color_black_label -text "black is:" -justify right -bg gray -width 10
entry .gene_color_black_entry -relief sunken -textvariable gene_color_black -bg lightblue -width 9
place .gene_color_black_label -x 10 -y 155 
place .gene_color_black_entry -x 90 -y 155 

label .gene_color_blue_label -text "blue is:" -justify right -bg gray -width 10
entry .gene_color_blue_entry -relief sunken -textvariable gene_color_blue -bg lightblue -width 9
place .gene_color_blue_label -x 10 -y 175 
place .gene_color_blue_entry -x 90 -y 175 

label .gene_color_brown_label -text "brown is:" -justify right -bg gray -width 10
entry .gene_color_brown_entry -relief sunken -textvariable gene_color_brown -bg lightblue -width 9
place .gene_color_brown_label -x 10 -y 195 
place .gene_color_brown_entry -x 90 -y 195 

label .gene_color_cyan_label -text "cyan is:" -justify right -bg gray -width 10
entry .gene_color_cyan_entry -relief sunken -textvariable gene_color_cyan -bg lightblue -width 9
place .gene_color_cyan_label -x 10 -y 215 
place .gene_color_cyan_entry -x 90 -y 215 

label .gene_color_gray_label -text "gray is:" -justify right -bg gray -width 10
entry .gene_color_gray_entry -relief sunken -textvariable gene_color_gray -bg lightblue -width 9
place .gene_color_gray_label -x 10 -y 235
place .gene_color_gray_entry -x 90 -y 235 

###########################################

label .gene_color_green_label -text "green is:" -justify right -bg gray -width 10
entry .gene_color_green_entry -relief sunken -textvariable gene_color_green -bg lightblue -width 9
place .gene_color_green_label -x 180 -y 155 
place .gene_color_green_entry -x 260 -y 155 

label .gene_color_lightblue_label -text "lightblue is:" -justify right -bg gray -width 10
entry .gene_color_lightblue_entry -relief sunken -textvariable gene_color_lightblue -bg lightblue -width 9
place .gene_color_lightblue_label -x 180 -y 175 
place .gene_color_lightblue_entry -x 260 -y 175 

label .gene_color_orange_label -text "orange is:" -justify right -bg gray -width 10
entry .gene_color_orange_entry -relief sunken -textvariable gene_color_orange -bg lightblue -width 9
place .gene_color_orange_label -x 180 -y 195 
place .gene_color_orange_entry -x 260 -y 195 

label .gene_color_pink_label -text "pink is:" -justify right -bg gray -width 10
entry .gene_color_pink_entry -relief sunken -textvariable gene_color_pink -bg lightblue -width 9
place .gene_color_pink_label -x 180 -y 215 
place .gene_color_pink_entry -x 260 -y 215 

label .gene_color_purple_label -text "purple is:" -justify right -bg gray -width 10
entry .gene_color_purple_entry -relief sunken -textvariable gene_color_purple -bg lightblue -width 9
place .gene_color_purple_label -x 180 -y 235 
place .gene_color_purple_entry -x 260 -y 235 

label .gene_color_gold_label -text "gold is:" -justify right -bg gray -width 10
entry .gene_color_gold_entry -relief sunken -textvariable gene_color_gold -bg lightblue -width 9
place .gene_color_gold_label -x 180 -y 255 
place .gene_color_gold_entry -x 260 -y 255 

###########################################

label .gene_color_red_label -text "red is:" -justify right -bg gray -width 10
entry .gene_color_red_entry -relief sunken -textvariable gene_color_red -bg lightblue -width 9
place .gene_color_red_label -x 350 -y 155 
place .gene_color_red_entry -x 430 -y 155 

label .gene_color_salmon_label -text "salmon is:" -justify right -bg gray -width 10
entry .gene_color_salmon_entry -relief sunken -textvariable gene_color_salmon -bg lightblue -width 9
place .gene_color_salmon_label -x 350 -y 175 
place .gene_color_salmon_entry -x 430 -y 175 

label .gene_color_violet_label -text "violet is:" -justify right -bg gray -width 10
entry .gene_color_violet_entry -relief sunken -textvariable gene_color_violet -bg lightblue -width 9
place .gene_color_violet_label -x 350 -y 195 
place .gene_color_violet_entry -x 430 -y 195 

label .gene_color_white_label -text "white is:" -justify right -bg gray -width 10
entry .gene_color_white_entry -relief sunken -textvariable gene_color_white -bg lightblue -width 9
place .gene_color_white_label -x 350 -y 215 
place .gene_color_white_entry -x 430 -y 215 

label .gene_color_yellow_label -text "yellow is:" -justify right -bg gray -width 10
entry .gene_color_yellow_entry -relief sunken -textvariable gene_color_yellow -bg lightblue -width 9
place .gene_color_yellow_label -x 350 -y 235 
place .gene_color_yellow_entry -x 430 -y 235 

####################
# CHROMOSOME COLOR #
global chromosome_color chromosome_outline canvas_background \
	default_outline_gene_color default_familyColor

set chromosome_color "gray"
set chromosome_outline "gray"
set canvas_background "white"

label .canvas_color_label -text "Canvas bg:" -justify right -bg gray -fg blue4 -width 10
entry .canvas_color_bg -relief sunken -textvariable canvas_background -bg lightgreen -width 9
place .canvas_color_label -x 10 -y 284
place .canvas_color_bg -x 90 -y 284

label .chrm_color_label -text "Chr color:" -justify right -bg gray -fg blue4 -width 10
entry .chrm_color -relief sunken -textvariable chromosome_color -bg lightgreen -width 9
place .chrm_color_label -x 350 -y 284
place .chrm_color -x 430 -y 284

label .chrm_outline_label -text "Chr outline:" -justify right -bg gray -fg blue4 -width 10
entry .chrm_outline -relief sunken -textvariable chromosome_outline -bg lightgreen -width 9
place .chrm_outline_label -x 350 -y 313
place .chrm_outline -x 430 -y 313

#####################
# some other colors #

global font_color_canvas

set font_color_canvas "black"

label .font_color -text "Font color:" -bg gray -fg blue4 -width 10
entry .font_color_entry -relief sunken -textvariable font_color_canvas -bg lightgreen -width 9

set default_outline_gene_color "black"
set default_familyColor "blue"

label .default_outline_gene_label -text "Gene outline:" -justify right -bg gray -fg blue4 -width 11
entry .default_outline_gene_entry -relief sunken -textvariable default_outline_gene_color \
	-bg lightgreen -width 9

label .default_familyColor_label -text "\"Similarity/Identity\" color:" \
	-justify right -bg gray -fg blue4 -width 23
entry .default_familyColor_entry -relief sunken -textvariable default_familyColor \
	-bg lightgreen -width 9

place .default_familyColor_label -x 90 -y 313
place .default_familyColor_entry -x 260 -y 313

place .default_outline_gene_label -x 343 -y 342
place .default_outline_gene_entry -x 430 -y 342

place .font_color -x 180 -y 284
place .font_color_entry -x 260 -y 284

######################################################
######                THE END                   ######
######################################################
